Attribute VB_Name = "Map"
Option Explicit

' Copyright (C) 1997-2012 Kei Sakamoto / Inui Tetsuyuki
' {vO̓t[\tgłAۏ؂łB
' {vOGNU General Public License(Ver.3܂͂ȍ~)߂̉
' ĔЕz܂͉ς邱Ƃł܂B

'}bvf[^Ɋւe폈sW[

'Ǘ\Ȓn`f[^̑
Public Const MAX_TERRAIN_DATA_NUM = 2000

'ADD START 240a
'C[̌Œl
Public Const NO_LAYER_NUM = 10000
'ADD  END  240a

'}bvt@C
Public MapFileName As String
'}bv̉TCY
Public MapWidth As Integer
'}bv̏cTCY
Public MapHeight As Integer

'}bv̕`惂[h
Public MapDrawMode As String
'tB^F
Public MapDrawFilterColor As Long
'tB^̓ߓx
Public MapDrawFilterTransPercent As Double
'tB^SepiaR}hȂǂŃjbg̐FύX邩
Public MapDrawIsMapOnly As Boolean

'}bvɉ摜݂̏Ȃꂽ
Public IsMapDirty As Boolean

'}bvf[^L^z
' MapData(*,*,0)͒n`̎
' MapData(*,*,1)̓rbg}bv̔ԍ
'ADD START 240a
'2`3̓}bvwC[f[^
' MapData(*,*,2)͒n`̎ށBݒNO_LAYER_NUM
' MapData(*,*,3)̓rbg}bv̔ԍBݒNO_LAYER_NUM
' MapData(*,*,4)̓}X̃f[^^CvB1:w 2:w 3:wf[^̂ 4:wڂ̂
'ADD  END  240a
Public MapData() As Integer

'ADD START 240a
Public Enum MapDataIndex
    TerrainType = 0
    BitmapNo = 1
    LayerType = 2
    LayerBitmapNo = 3
    BoxType = 4
End Enum
Public Enum BoxTypes
    Under = 1
    Upper = 2
    UpperDataOnly = 3
    UpperBmpOnly = 4
End Enum
'ADD  END  240a

'}bv̉摜t@C̊i[`
Enum MapImageFileType
    OldMapImageFileType         '` (plain0.bmp)
    FourFiguresMapImageFileType 'S̐l (plain0000.bmp)
    SeparateDirMapImageFileType 'fBNg (plain\plain0000.bmp)
End Enum
Public MapImageFileTypeData() As MapImageFileType

'}bvɑ݂郆jbgL^z
Public MapDataForUnit() As Unit

'}bvŃ^[QbgIۂ̃}XN
Public MaskData() As Boolean

'ݒn_炻̒n_܂ňړ̂ɕKvȈړ͂̔z
Public TotalMoveCost() As Long

'en_ynb̉eɂ邩ǂ
Public PointInZOC() As Long


'n`e[u
Public Sub InitMap()
Dim i As Integer, j As Integer
    
    SetMapSize MainWidth, MainHeight
    
    For i = 1 To MapWidth
        For j = 1 To MapHeight
'MOD START 240a
'            MapData(i, j, 0) = 0
'            MapData(i, j, 1) = 0
            MapData(i, j, MapDataIndex.TerrainType) = 0
            MapData(i, j, MapDataIndex.BitmapNo) = 0
            MapData(i, j, MapDataIndex.LayerType) = 0
            MapData(i, j, MapDataIndex.LayerBitmapNo) = 0
            MapData(i, j, MapDataIndex.BoxType) = 0
'ADD  END  240a
        Next
    Next
End Sub

'(X,Y)n_̖C
Public Function TerrainEffectForHit(ByVal X As Integer, ByVal Y As Integer) As Integer
'MOD START 240a
'    TerrainEffectForHit = TDList.HitMod(MapData(X, Y, 0))
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainEffectForHit = TDList.HitMod(MapData(X, Y, MapDataIndex.TerrainType))
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainEffectForHit = TDList.HitMod(MapData(X, Y, MapDataIndex.LayerType))
    End Select
'MOD  END  240a
End Function

'(X,Y)n_̃_[WC
Public Function TerrainEffectForDamage(ByVal X As Integer, ByVal Y As Integer) As Integer
'MOD START 240a
'    TerrainEffectForDamage = TDList.DamageMod(MapData(X, Y, 0))
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainEffectForDamage = TDList.DamageMod(MapData(X, Y, MapDataIndex.TerrainType))
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainEffectForDamage = TDList.DamageMod(MapData(X, Y, MapDataIndex.LayerType))
    End Select
'MOD  END  240a
End Function

'(X,Y)n_̂go񕜗
Public Function TerrainEffectForHPRecover(ByVal X As Integer, ByVal Y As Integer) As Integer
'MOD START 240a
'    TerrainEffectForHPRecover = 10 * TDList.FeatureLevel(MapData(X, Y, 0), "go")
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainEffectForHPRecover = 10 * TDList.FeatureLevel(MapData(X, Y, MapDataIndex.TerrainType), "go")
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainEffectForHPRecover = 10 * TDList.FeatureLevel(MapData(X, Y, MapDataIndex.LayerType), "go")
    End Select
'MOD  END  240a
End Function

'(X,Y)n_̂dm񕜗
Public Function TerrainEffectForENRecover(ByVal X As Integer, ByVal Y As Integer) As Integer
'MOD START 240a
'    TerrainEffectForENRecover = 10 * TDList.FeatureLevel(MapData(X, Y, 0), "dm")
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainEffectForENRecover = 10 * TDList.FeatureLevel(MapData(X, Y, MapDataIndex.TerrainType), "dm")
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainEffectForENRecover = 10 * TDList.FeatureLevel(MapData(X, Y, MapDataIndex.LayerType), "dm")
    End Select
'MOD  END  240a
End Function

'(X,Y)n_̒n`
Public Function TerrainName(ByVal X As Integer, ByVal Y As Integer) As String
'MOD START 240a
'    TerrainName = TDList.Name(MapData(X, Y, 0))
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainName = TDList.Name(MapData(X, Y, MapDataIndex.TerrainType))
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainName = TDList.Name(MapData(X, Y, MapDataIndex.LayerType))
    End Select
'MOD  END  240a
End Function

'(X,Y)n_̒n`NX
Public Function TerrainClass(ByVal X As Integer, ByVal Y As Integer) As String
'MOD START 240a
'    TerrainClass = TDList.Class(MapData(X, Y, 0))
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainClass = TDList.Class(MapData(X, Y, MapDataIndex.TerrainType))
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainClass = TDList.Class(MapData(X, Y, MapDataIndex.LayerType))
    End Select
'MOD  END  240a
End Function

'(X,Y)n_̈ړRXg
Public Function TerrainMoveCost(ByVal X As Integer, ByVal Y As Integer) As Integer
'MOD START 240a
'    TerrainMoveCost = TDList.MoveCost(MapData(X, Y, 0))
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainMoveCost = TDList.MoveCost(MapData(X, Y, MapDataIndex.TerrainType))
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainMoveCost = TDList.MoveCost(MapData(X, Y, MapDataIndex.LayerType))
    End Select
'MOD  END  240a
End Function

'(X,Y)n_ɏQ邩 (΂ɏՓ˂邩)
Public Function TerrainHasObstacle(ByVal X As Integer, ByVal Y As Integer) As Boolean
'MOD START 240a
'    TerrainHasObstacle = TDList.IsFeatureAvailable(MapData(X, Y, 0), "Փ")
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainHasObstacle = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.TerrainType), "Փ")
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainHasObstacle = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.LayerType), "Փ")
    End Select
'MOD  END  240a
End Function

'ADD START 240a
'(X,Y)n_ړ~
Public Function TerrainHasMoveStop(ByVal X As Integer, ByVal Y As Integer) As Boolean
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainHasMoveStop = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.TerrainType), "ړ~")
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainHasMoveStop = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.LayerType), "ړ~")
    End Select
End Function

'(X,Y)n_i֎~
Public Function TerrainDoNotEnter(ByVal X As Integer, ByVal Y As Integer) As Boolean
    Dim ret As Boolean
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        ret = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.TerrainType), "i֎~")
        If Not ret Then
            '݊ێ̂ߎcĂ
            ret = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.TerrainType), "N֎~")
        End If
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        ret = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.LayerType), "i֎~")
        If Not ret Then
            '݊ێ̂ߎcĂ
            ret = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.LayerType), "N֎~")
        End If
    End Select
End Function

'(X,Y)n_w肵\͂Ă邩
Public Function TerrainHasFeature(ByVal X As Integer, ByVal Y As Integer, Feature As String) As Boolean
    Select Case MapData(X, Y, MapDataIndex.BoxType)
    Case BoxTypes.Under, BoxTypes.UpperBmpOnly
        'wCꍇƏw摜񂵂ĂȂꍇ͉w̃f[^Ԃ
        TerrainHasFeature = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.TerrainType), Feature)
    Case Else
        'wCĂꍇƏ̂ݎĂꍇ͏w̃f[^Ԃ
        TerrainHasFeature = TDList.IsFeatureAvailable(MapData(X, Y, MapDataIndex.LayerType), Feature)
    End Select
End Function
'ADD  END  240a

'(X,Y)n_ɂ郆jbg
Public Function UnitAtPoint(ByVal X As Integer, ByVal Y As Integer) As Unit
    If X < 1 Or MapWidth < X Then
        Set UnitAtPoint = Nothing
        Exit Function
    End If
    If Y < 1 Or MapHeight < Y Then
        Set UnitAtPoint = Nothing
        Exit Function
    End If
    Set UnitAtPoint = MapDataForUnit(X, Y)
End Function

'w肵}bv摜
Public Function SearchTerrainImageFile(ByVal tid As Integer, ByVal tbitmap As Integer, _
    ByVal tx As Integer, ByVal ty As Integer) As String
Dim tbmpname As String
Dim fname1 As String, fname2 As String, fname3 As String
Static init_setup_background As Boolean
Static scenario_map_dir_exists As Boolean
Static extdata_map_dir_exists As Boolean
Static extdata2_map_dir_exists As Boolean

'ADD START 240a
    '摜m肵ĂȂ珈Ȃ
    If tid = NO_LAYER_NUM Then
        Exit Function
    ElseIf tbitmap = NO_LAYER_NUM Then
        Exit Function
    End If
'ADD  END  240a

    '߂ĎsۂɁAetH_Bitmap\MaptH_邩`FbN
    If Not init_setup_background Then
        If Len(Dir$(ScenarioPath & "Bitmap\Map", vbDirectory)) > 0 Then
            scenario_map_dir_exists = True
        End If
        If Len(Dir$(ExtDataPath & "Bitmap\Map", vbDirectory)) > 0 Then
            extdata_map_dir_exists = True
        End If
        If Len(Dir$(ExtDataPath2 & "Bitmap\Map", vbDirectory)) > 0 Then
            extdata2_map_dir_exists = True
        End If
        init_setup_background = True
    End If
    
    '}bv摜̃t@C쐬
    tbmpname = TDList.Bitmap(tid)
    fname1 = "\Bitmap\Map\" & tbmpname & "\" & tbmpname & Format$(tbitmap, "0000") & ".bmp"
    fname2 = "\Bitmap\Map\" & tbmpname & Format$(tbitmap, "0000") & ".bmp"
    fname3 = "\Bitmap\Map\" & tbmpname & Format$(tbitmap) & ".bmp"
    
    'rbg}bvT
    If scenario_map_dir_exists Then
        If FileExists(ScenarioPath & fname1) Then
            SearchTerrainImageFile = ScenarioPath & fname1
            MapImageFileTypeData(tx, ty) = SeparateDirMapImageFileType
            Exit Function
        End If
        If FileExists(ScenarioPath & fname2) Then
            SearchTerrainImageFile = ScenarioPath & fname2
            MapImageFileTypeData(tx, ty) = FourFiguresMapImageFileType
            Exit Function
        End If
        If FileExists(ScenarioPath & fname3) Then
            SearchTerrainImageFile = ScenarioPath & fname3
            MapImageFileTypeData(tx, ty) = OldMapImageFileType
            Exit Function
        End If
    End If
    If extdata_map_dir_exists Then
        If FileExists(ExtDataPath & fname1) Then
            SearchTerrainImageFile = ExtDataPath & fname1
            MapImageFileTypeData(tx, ty) = SeparateDirMapImageFileType
            Exit Function
        End If
        If FileExists(ExtDataPath & fname2) Then
            SearchTerrainImageFile = ExtDataPath & fname2
            MapImageFileTypeData(tx, ty) = FourFiguresMapImageFileType
            Exit Function
        End If
        If FileExists(ExtDataPath & fname3) Then
            SearchTerrainImageFile = ExtDataPath & fname3
            MapImageFileTypeData(tx, ty) = OldMapImageFileType
            Exit Function
        End If
    End If
    If extdata2_map_dir_exists Then
        If FileExists(ExtDataPath2 & fname1) Then
            SearchTerrainImageFile = ExtDataPath2 & fname1
            MapImageFileTypeData(tx, ty) = SeparateDirMapImageFileType
            Exit Function
        End If
        If FileExists(ExtDataPath2 & fname2) Then
            SearchTerrainImageFile = ExtDataPath2 & fname2
            MapImageFileTypeData(tx, ty) = FourFiguresMapImageFileType
            Exit Function
        End If
        If FileExists(ExtDataPath2 & fname3) Then
            SearchTerrainImageFile = ExtDataPath2 & fname3
            MapImageFileTypeData(tx, ty) = OldMapImageFileType
            Exit Function
        End If
    End If
    If FileExists(AppPath & fname1) Then
        SearchTerrainImageFile = AppPath & fname1
        MapImageFileTypeData(tx, ty) = SeparateDirMapImageFileType
        Exit Function
    End If
    If FileExists(AppPath & fname2) Then
        SearchTerrainImageFile = AppPath & fname2
        MapImageFileTypeData(tx, ty) = FourFiguresMapImageFileType
        Exit Function
    End If
    If FileExists(AppPath & fname3) Then
        SearchTerrainImageFile = AppPath & fname3
        MapImageFileTypeData(tx, ty) = OldMapImageFileType
        Exit Function
    End If
End Function


'}bvt@C fname ̃f[^[h
Public Sub LoadMapData(fname As String)
Dim FileNumber As Integer
Dim i As Integer, j As Integer
Dim buf As String
    
    't@C݂Ȃꍇ
    If fname = "" Or Not FileExists(fname) Then
        MapFileName = ""
        If InStr(ScenarioFileName, "Xe[^X\.") > 0 _
            Or InStr(ScenarioFileName, "LO.") > 0 _
        Then
            SetMapSize MainWidth, 40
        Else
            SetMapSize MainWidth, MainHeight
        End If
        For i = 1 To MapWidth
            For j = 1 To MapHeight
'MOD START 240a
'                MapData(i, j, 0) = MAX_TERRAIN_DATA_NUM
'                MapData(i, j, 1) = 0
                't@Cꍇ
                MapData(i, j, MapDataIndex.TerrainType) = MAX_TERRAIN_DATA_NUM
                MapData(i, j, MapDataIndex.BitmapNo) = 0
                MapData(i, j, MapDataIndex.LayerType) = NO_LAYER_NUM
                MapData(i, j, MapDataIndex.LayerBitmapNo) = NO_LAYER_NUM
                MapData(i, j, MapDataIndex.BoxType) = BoxTypes.Under
'MOD  END  240a
            Next
        Next
        Exit Sub
    End If
    
    On Error GoTo ErrorHandler
    
    't@CJ
    FileNumber = FreeFile
    Open fname For Input As #FileNumber
    
    't@CL^Ă
    MapFileName = fname
    
    't@C̐擪ɂ}bvTCY
    Input #FileNumber, buf
    If buf <> "MapData" Then
        '`̃}bvf[^
        SetMapSize 20, 20
        Close #FileNumber
        
        FileNumber = FreeFile
        Open fname For Input As #FileNumber
    Else
        Input #FileNumber, buf
        Input #FileNumber, i, j
        SetMapSize i, j
    End If
    
    '}bvf[^ǂݍ
    For i = 1 To MapWidth
        For j = 1 To MapHeight
'MOD START 240a
'            Input #FileNumber, MapData(i, j, 0), MapData(i, j, 1)
'            If Not TDList.IsDefined(MapData(i, j, 0)) Then
'                MsgBox "`ĂȂ" & Format$(MapData(i, j, 0)) _
'                    & "Ԃ̒n`f[^gĂ܂"
            Input #FileNumber, MapData(i, j, MapDataIndex.TerrainType), MapData(i, j, MapDataIndex.BitmapNo)
            If Not TDList.IsDefined(MapData(i, j, MapDataIndex.TerrainType)) Then
                MsgBox "`ĂȂ" & Format$(MapData(i, j, MapDataIndex.TerrainType)) _
                    & "Ԃ̒n`f[^gĂ܂"
'MOD  END  240a
                Close #FileNumber
                End
            End If
        Next
    Next

'ADD START 240a
    'C[f[^ǂݍ
    If Not EOF(FileNumber) Then
        Input #FileNumber, buf
        If buf = "Layer" Then
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    Input #FileNumber, MapData(i, j, MapDataIndex.LayerType), MapData(i, j, MapDataIndex.LayerBitmapNo)
                    If (MapData(i, j, MapDataIndex.LayerType) <> NO_LAYER_NUM) Then
                        '`Ăf[^̑Ó`FbN
                        If Not TDList.IsDefined(MapData(i, j, MapDataIndex.LayerType)) Then
                            MsgBox "`ĂȂ" & Format$(MapData(i, j, MapDataIndex.LayerType)) & "Ԃ̒n`f[^gĂ܂"
                            Close #FileNumber
                            End
                        End If
                        '}X̃^Cvw
                        MapData(i, j, MapDataIndex.BoxType) = BoxTypes.Upper
                    Else
                        '}X̃^CvwɁiwAēxIɐݒ肷j
                        MapData(i, j, MapDataIndex.BoxType) = BoxTypes.Under
                    End If
                Next
            Next
        End If
    End If
'ADD  END  240a
    
    Close #FileNumber
    Exit Sub
    
ErrorHandler:
    ErrorMessage "}bvt@Cu" & fname & "ṽf[^sł"
    Close #FileNumber
    End
End Sub

'}bvTCYݒ
Public Sub SetMapSize(ByVal w As Integer, ByVal h As Integer)
Dim i As Integer, j As Integer, ret As Long

    MapWidth = w
    MapHeight = h
    MapPWidth = 32 * w
    MapPHeight = 32 * h
    MapX = (MainWidth + 1) \ 2
    MapY = (MainHeight + 1) \ 2
    
    '}bv摜TCY
    With MainForm.picBack
        .Picture = LoadPicture("")
        .Move 0, 0, MapPWidth, MapPHeight
        ret = PatBlt(.hDC, 0, 0, .width, .Height, BLACKNESS)
    End With
    With MainForm.picMaskedBack
        .Picture = LoadPicture("")
        .Move 0, 0, MapPWidth, MapPHeight
    End With
    
    'XN[o[̈ړ͈͂
    With MainForm.HScroll
        If .max <> MapWidth Then
            .Visible = False
            .max = MapWidth
'MOD START 240a
'            If MainWidth = 15 Then
            If Not NewGUIMode Then
'MOD  END  240a
                .Visible = True
            End If
        End If
    End With
    With MainForm.VScroll
        If .max <> MapHeight Then
            .Visible = False
            .max = MapHeight
'MOD START 240a
'            If MainWidth = 15 Then
            If Not NewGUIMode Then
'MOD  END  240a
                .Visible = True
            End If
        End If
    End With
    
    '}bvf[^pz̗̈m
'MOD START 240a
'    ReDim MapData(1 To MapWidth, 1 To MapHeight, 1)
    ReDim MapData(1 To MapWidth, 1 To MapHeight, 4)
'MOD  END  240a
    ReDim MapDataForUnit(1 To MapWidth, 1 To MapHeight)
    ReDim MaskData(1 To MapWidth, 1 To MapHeight)
    ReDim TotalMoveCost(0 To MapWidth + 1, 0 To MapHeight + 1)
    ReDim PointInZOC(0 To MapWidth + 1, 0 To MapHeight + 1)
    ReDim MapImageFileTypeData(1 To MapWidth, 1 To MapHeight)
    
    '}bvf[^z̏
    For i = 1 To MapWidth
        For j = 1 To MapHeight
'MOD START 240a
'            MapData(i, j, 0) = 0
'            MapData(i, j, 1) = 0
            MapData(i, j, MapDataIndex.TerrainType) = 0
            MapData(i, j, MapDataIndex.BitmapNo) = 0
            MapData(i, j, MapDataIndex.LayerType) = NO_LAYER_NUM
            MapData(i, j, MapDataIndex.LayerBitmapNo) = NO_LAYER_NUM
            MapData(i, j, MapDataIndex.BoxType) = BoxTypes.Under
'MOD  END  240a
            MaskData(i, j) = True
            Set MapDataForUnit(i, j) = Nothing
        Next
    Next
End Sub

'}bvf[^NA
Public Sub ClearMap()
Dim ret As Long

    MapFileName = ""
    MapWidth = 1
    MapHeight = 1
    
'MOD START 240a
'    ReDim MapData(1, 1, 1)
    ReDim MapData(1, 1, 4)
'MOD  END  240a
    ReDim MapDataForUnit(1, 1)
    ReDim MaskData(1, 1)
    
'MOD START 240a
'    MapData(1, 1, 0) = 0
'    MapData(1, 1, 1) = 0
    MapData(1, 1, MapDataIndex.TerrainType) = 0
    MapData(1, 1, MapDataIndex.BitmapNo) = 0
    MapData(1, 1, MapDataIndex.LayerType) = 0
    MapData(1, 1, MapDataIndex.LayerBitmapNo) = 0
    MapData(1, 1, MapDataIndex.BoxType) = 0
'MOD  END  240a
    Set MapDataForUnit(1, 1) = Nothing
    
    '}bvʂ
    With MainForm.picBack
        ret = PatBlt(.hDC, 0, 0, .width, .Height, BLACKNESS)
    End With
    With MainForm.picMain(0)
        ret = PatBlt(.hDC, 0, 0, .width, .Height, BLACKNESS)
    End With
    
    'jbg摜Zbg
    If MapDrawMode <> "" And Not MapDrawIsMapOnly Then
        UList.ClearUnitBitmap
    End If
    
    MapDrawMode = ""
    MapDrawIsMapOnly = False
    MapDrawFilterColor = 0
    MapDrawFilterTransPercent = 0
End Sub


'fpZ[uf[^Ƀ}bvf[^Z[u
Public Sub DumpMapData()
Dim i As Integer, j As Integer
Dim fname As String

    If InStr(MapFileName, ScenarioPath) = 1 Then
        fname = Right$(MapFileName, Len(MapFileName) - Len(ScenarioPath))
    Else
        fname = MapFileName
    End If
    
    
    If MapDrawIsMapOnly Then
        Write #SaveDataFileNumber, fname, MapDrawMode & "(}bv)"
    Else
        Write #SaveDataFileNumber, fname, MapDrawMode
    End If
    Write #SaveDataFileNumber, MapWidth, MapHeight
    
    For i = 1 To MapWidth
        For j = 1 To MapHeight
'MOD START 240a
'            Write #SaveDataFileNumber, MapData(i, j, 0), MapData(i, j, 1)
            Write #SaveDataFileNumber, MapData(i, j, MapDataIndex.TerrainType), MapData(i, j, MapDataIndex.BitmapNo)
'ADD  END  240a
        Next
    Next
    
    Write #SaveDataFileNumber, MapX, MapY
    
'ADD START 240a
    'C
    Write #SaveDataFileNumber, "Layer"
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            Write #SaveDataFileNumber, MapData(i, j, MapDataIndex.LayerType), MapData(i, j, MapDataIndex.LayerBitmapNo), MapData(i, j, MapDataIndex.BoxType)
        Next
    Next
'ADD  END  240a
    
End Sub

'fpZ[uf[^}bvf[^[h
'MOD START 240a
'SubFunction
'Public Sub RestoreMapData() As String
Public Function RestoreMapData() As String
'MOD  END  240a
Dim sbuf1 As String, sbuf2 As String
Dim ibuf1 As Integer, ibuf2 As Integer
'ADD START 240a
Dim ibuf3 As Integer, ibuf4 As Integer
Dim buf As String
'ADD  END  240a
Dim i As Integer, j As Integer
Dim is_map_changed As Boolean
Dim u As Unit
    
    '}bvt@C, }bv`@
    Input #SaveDataFileNumber, sbuf1, sbuf2
    If InStr(sbuf1, ":") = 0 Then
        sbuf1 = ScenarioPath & sbuf1
    End If
    If sbuf1 <> MapFileName Then
        MapFileName = sbuf1
        is_map_changed = True
    End If
    If MapDrawIsMapOnly Then
        If sbuf2 <> MapDrawMode & "(}bv)" Then
            If Right$(sbuf2, 7) = "(}bv)" Then
                MapDrawMode = Left$(sbuf2, Len(sbuf2) - 7)
                MapDrawIsMapOnly = True
            Else
                MapDrawMode = sbuf2
                MapDrawIsMapOnly = False
            End If
            UList.ClearUnitBitmap
            is_map_changed = True
        End If
    Else
        If sbuf2 <> MapDrawMode Then
            If Right$(sbuf2, 7) = "(}bv)" Then
                MapDrawMode = Left$(sbuf2, Len(sbuf2) - 7)
                MapDrawIsMapOnly = True
            Else
                MapDrawMode = sbuf2
                MapDrawIsMapOnly = False
            End If
            UList.ClearUnitBitmap
            is_map_changed = True
        End If
    End If
    
    '}bv, }bv
    Input #SaveDataFileNumber, ibuf1, ibuf2
    If ibuf1 <> MapWidth Or ibuf2 <> MapHeight Then
        SetMapSize ibuf1, ibuf2
    End If
    
    'en`
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            Input #SaveDataFileNumber, ibuf1, ibuf2
'MOD START 240a
'            If ibuf1 <> MapData(i, j, 0) Then
'                MapData(i, j, 0) = ibuf1
'                is_map_changed = True
'            End If
'            If ibuf2 <> MapData(i, j, 1) Then
'                MapData(i, j, 1) = ibuf2
'                is_map_changed = True
'            End If
            If ibuf1 <> MapData(i, j, MapDataIndex.TerrainType) Then
                MapData(i, j, MapDataIndex.TerrainType) = ibuf1
                is_map_changed = True
            End If
            If ibuf2 <> MapData(i, j, MapDataIndex.BitmapNo) Then
                MapData(i, j, MapDataIndex.BitmapNo) = ibuf2
                is_map_changed = True
            End If
'MOD  END  240a
        Next
    Next
    
'MOV START 240a
'    'wi̕KvLH
'    If is_map_changed Then
'        IsMapDirty = True
'    End If
'MOV  END  240a
    
    '\ʒu
    'SetupBackgroundMapX,MapYĂ܂߁Äʒu
    'lQƂKvB
    Input #SaveDataFileNumber, MapX, MapY
    
'ADD START 240a
    Input #SaveDataFileNumber, buf
    If "Layer" = buf Then
        'eC
        For i = 1 To MapWidth
            For j = 1 To MapHeight
                Input #SaveDataFileNumber, ibuf1, ibuf2, ibuf3
                If ibuf1 <> MapData(i, j, MapDataIndex.LayerType) Then
                    MapData(i, j, MapDataIndex.LayerType) = ibuf1
                    is_map_changed = True
                End If
                If ibuf2 <> MapData(i, j, MapDataIndex.LayerBitmapNo) Then
                    MapData(i, j, MapDataIndex.LayerBitmapNo) = ibuf2
                    is_map_changed = True
                End If
                If ibuf3 <> MapData(i, j, MapDataIndex.BoxType) Then
                    MapData(i, j, MapDataIndex.BoxType) = ibuf3
                    is_map_changed = True
                End If
            Next
        Next
        'afl֘A1sڂǂݍ
        Input #SaveDataFileNumber, buf
    End If
    RestoreMapData = buf
    'wi̕KvLH
    If is_map_changed Then
        IsMapDirty = True
    End If
'ADD  END  240a
    
    'jbgzu
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            Set MapDataForUnit(i, j) = Nothing
        Next
    Next
    For Each u In UList
        With u
            If .Status = "o" Then
                Set MapDataForUnit(.X, .Y) = u
            End If
        End With
    Next
End Function


'(X,Y)𒆐SƂ min_range - max_range ̃GAI
'GÃjbg uparty ̎wɏ]I
Public Sub AreaInRange(ByVal X As Integer, ByVal Y As Integer, _
    ByVal max_range As Integer, ByVal min_range As Integer, _
    uparty As String)
Dim x1 As Integer, y1 As Integer
Dim x2 As Integer, y2 As Integer
Dim i As Integer, j As Integer
Dim n As Integer
    
    'INA
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            MaskData(i, j) = True
        Next
    Next
    
    x1 = MaxLng(X - max_range, 1)
    x2 = MinLng(X + max_range, MapWidth)
    y1 = MaxLng(Y - max_range, 1)
    y2 = MinLng(Y + max_range, MapHeight)
    
    'max_rangemin_rangeÕGAI
    For i = x1 To x2
        For j = y1 To y2
            n = Abs(X - i) + Abs(Y - j)
            If n <= max_range Then
                If n >= min_range Then
                    MaskData(i, j) = False
                End If
            End If
        Next
    Next
    
    'GÃjbgI邩ꂼꔻ
    Select Case uparty
        Case "", "mob"
            For i = x1 To x2
                For j = y1 To y2
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            If Not MapDataForUnit(i, j).Party = "" _
                                And Not MapDataForUnit(i, j).Party = "mob" _
                            Then
                                MaskData(i, j) = True
                            End If
                        End If
                    End If
                Next
            Next
        Case "̓G", "mob̓G"
            For i = x1 To x2
                For j = y1 To y2
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            With MapDataForUnit(i, j)
                                If (.Party = "" Or .Party = "mob") _
                                    And Not .IsConditionSatisfied("\") _
                                    And Not .IsConditionSatisfied("") _
                                    And Not .IsConditionSatisfied("") _
                                    And Not .IsConditionSatisfied("߈") _
                                    And Not .IsConditionSatisfied("") _
                                Then
                                    MaskData(i, j) = True
                                End If
                            End With
                        End If
                    End If
                Next
            Next
        Case "G"
            For i = x1 To x2
                For j = y1 To y2
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            If Not MapDataForUnit(i, j).Party = "G" Then
                                MaskData(i, j) = True
                            End If
                        End If
                    End If
                Next
            Next
        Case "G̓G"
            For i = x1 To x2
                For j = y1 To y2
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            With MapDataForUnit(i, j)
                                If .Party = "G" Then
                                    MaskData(i, j) = True
                                End If
                            End With
                        End If
                    End If
                Next
            Next
        Case ""
            For i = x1 To x2
                For j = y1 To y2
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            If Not MapDataForUnit(i, j).Party = "" Then
                                MaskData(i, j) = True
                            End If
                        End If
                    End If
                Next
            Next
        Case "̓G"
            For i = x1 To x2
                For j = y1 To y2
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            With MapDataForUnit(i, j)
                                If .Party = "" Then
                                    MaskData(i, j) = True
                                End If
                            End With
                        End If
                    End If
                Next
            Next
        Case ""
            For i = x1 To x2
                For j = y1 To y2
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            MaskData(i, j) = True
                        End If
                    End If
                Next
            Next
        Case "S", ""
    End Select
    
    'GA̒S͏ɑI
    MaskData(X, Y) = False
End Sub

'jbg u ړgp\Ȏ˒ max_range ̕^AreBgꍇ̌ʔ͈
'GÃjbg Party ̎wɏ]I
Public Sub AreaInReachable(u As Unit, ByVal max_range As Integer, uparty As String)
Dim tmp_mask_data() As Boolean
Dim i As Integer, j As Integer, k As Integer
    
    '܂͈ړ͈͂I
    AreaInSpeed u
    
    'I͈͂max_rangeԂ񂾂g
    ReDim tmp_mask_data(0 To MapWidth + 1, 0 To MapHeight + 1)
    For i = 0 To MapWidth + 1
        For j = 0 To MapHeight + 1
            tmp_mask_data(i, j) = True
        Next
    Next
    For i = 1 To max_range
        For j = 1 To MapWidth
            For k = 1 To MapHeight
                tmp_mask_data(j, k) = MaskData(j, k)
            Next
        Next
        For j = 1 To MapWidth
            For k = 1 To MapHeight
                MaskData(j, k) = tmp_mask_data(j, k) _
                    And tmp_mask_data(j - 1, k) _
                    And tmp_mask_data(j + 1, k) _
                    And tmp_mask_data(j, k - 1) _
                    And tmp_mask_data(j, k + 1)
            Next
        Next
    Next
    
    'GÃjbgI邩ꂼꔻ
    Select Case uparty
        Case "", "mob"
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            If Not MapDataForUnit(i, j).Party = "" _
                                And Not MapDataForUnit(i, j).Party = "mob" _
                            Then
                                MaskData(i, j) = True
                            End If
                        End If
                    End If
                Next
            Next
        Case "̓G", "mob̓G"
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            With MapDataForUnit(i, j)
                                If (.Party = "" Or .Party = "mob") _
                                    And Not .IsConditionSatisfied("\") _
                                    And Not .IsConditionSatisfied("") _
                                    And Not .IsConditionSatisfied("߈") _
                                Then
                                    MaskData(i, j) = True
                                End If
                            End With
                        End If
                    End If
                Next
            Next
        Case "G"
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            If Not MapDataForUnit(i, j).Party = "G" Then
                                MaskData(i, j) = True
                            End If
                        End If
                    End If
                Next
            Next
        Case "G̓G"
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            With MapDataForUnit(i, j)
                                If .Party = "G" Then
                                    MaskData(i, j) = True
                                End If
                            End With
                        End If
                    End If
                Next
            Next
        Case ""
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            If Not MapDataForUnit(i, j).Party = "" Then
                                MaskData(i, j) = True
                            End If
                        End If
                    End If
                Next
            Next
        Case "̓G"
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            With MapDataForUnit(i, j)
                                If .Party = "" Then
                                    MaskData(i, j) = True
                                End If
                            End With
                        End If
                    End If
                Next
            Next
        Case ""
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    If Not MaskData(i, j) Then
                        If Not MapDataForUnit(i, j) Is Nothing Then
                            MaskData(i, j) = True
                        End If
                    End If
                Next
            Next
        Case "S", ""
    End Select
    
    'GA̒S͏ɑI
    MaskData(u.X, u.Y) = False
End Sub

'}bvSɓnupartyɑ郆jbg݂ꏊI
Public Sub AreaWithUnit(uparty As String)
Dim i As Integer, j As Integer
Dim u As Unit

    For i = 1 To MapWidth
        For j = 1 To MapHeight
            MaskData(i, j) = True
        Next
    Next
    
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            Set u = MapDataForUnit(i, j)
            If u Is Nothing Then
                GoTo NextLoop
            End If
            
            With u
                Select Case uparty
                    Case ""
                        If .Party = "" Or .Party = "mob" Then
                            MaskData(i, j) = False
                        End If
                    Case "̓G"
                        If .Party <> "" And .Party <> "mob" Then
                            MaskData(i, j) = False
                        End If
                    Case "G"
                        If .Party = "G" Then
                            MaskData(i, j) = False
                        End If
                    Case "G̓G"
                        If .Party <> "G" Then
                            MaskData(i, j) = False
                        End If
                    Case ""
                        If .Party = "" Then
                            MaskData(i, j) = False
                        End If
                    Case "̓G"
                        If .Party <> "" Then
                            MaskData(i, j) = False
                        End If
                    Case Else
                        MaskData(i, j) = False
                End Select
            End With
NextLoop:
        Next
    Next
End Sub

'\̃GAI (l̍UIp)
Public Sub AreaInCross(ByVal X As Integer, ByVal Y As Integer, _
    ByVal min_range As Integer, max_range As Integer)
Dim i As Integer, j As Integer
    
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            MaskData(i, j) = True
        Next
    Next
    
    For i = Y - max_range To Y - min_range
        If i >= 1 Then
            MaskData(X, i) = False
        End If
    Next
    For i = Y + min_range To Y + max_range
        If i <= MapHeight Then
            MaskData(X, i) = False
        End If
    Next
    For i = X - max_range To X - min_range
        If i >= 1 Then
            MaskData(i, Y) = False
        End If
    Next
    For i = X + min_range To X + max_range
        If i <= MapWidth Then
            MaskData(i, Y) = False
        End If
    Next
    MaskData(X, Y) = False
End Sub

'̃GAI (l̍U͈͐ݒp)
Public Sub AreaInLine(ByVal X As Integer, ByVal Y As Integer, _
    ByVal min_range As Integer, max_range As Integer, direction As String)
Dim i As Integer, j As Integer
    
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            MaskData(i, j) = True
        Next
    Next
    
    Select Case direction
        Case "N"
            For i = Y - max_range To Y - min_range
                If i >= 1 Then
                    MaskData(X, i) = False
                End If
            Next
        Case "S"
            For i = Y + min_range To Y + max_range
                If i <= MapHeight Then
                    MaskData(X, i) = False
                End If
            Next
        Case "W"
            For i = X - max_range To X - min_range
                If i >= 1 Then
                    MaskData(i, Y) = False
                End If
            Next
        Case "E"
            For i = X + min_range To X + max_range
                If i <= MapWidth Then
                    MaskData(i, Y) = False
                End If
            Next
    End Select
    MaskData(X, Y) = False
End Sub

'R}X̏\̃GAI (lg̍UIp)
Public Sub AreaInWideCross(ByVal X As Integer, ByVal Y As Integer, _
    ByVal min_range As Integer, max_range As Integer)
Dim i As Integer, j As Integer
    
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            MaskData(i, j) = True
        Next
    Next
    
    For i = Y - max_range To Y - min_range
        If i >= 1 Then
            MaskData(X, i) = False
        End If
    Next
    For i = Y - max_range + 1 To Y - (min_range + 1)
        If i >= 1 Then
            If X > 1 Then
                MaskData(X - 1, i) = False
            End If
            If X < MapWidth Then
                MaskData(X + 1, i) = False
            End If
        End If
    Next
    
    For i = Y + min_range To Y + max_range
        If i <= MapHeight Then
            MaskData(X, i) = False
        End If
    Next
    For i = Y + (min_range + 1) To Y + max_range - 1
        If i <= MapHeight Then
            If X > 1 Then
                MaskData(X - 1, i) = False
            End If
            If X < MapWidth Then
                MaskData(X + 1, i) = False
            End If
        End If
    Next
    
    For i = X - max_range To X - min_range
        If i >= 1 Then
            MaskData(i, Y) = False
        End If
    Next
    For i = X - max_range + 1 To X - (min_range + 1)
        If i >= 1 Then
            If Y > 1 Then
                MaskData(i, Y - 1) = False
            End If
            If Y < MapHeight Then
                MaskData(i, Y + 1) = False
            End If
        End If
    Next
    
    For i = X + min_range To X + max_range
        If i <= MapWidth Then
            MaskData(i, Y) = False
        End If
    Next
    For i = X + (min_range + 1) To X + max_range - 1
        If i <= MapWidth Then
            If Y > 1 Then
                MaskData(i, Y - 1) = False
            End If
            If Y < MapHeight Then
                MaskData(i, Y + 1) = False
            End If
        End If
    Next
    
    MaskData(X, Y) = False
End Sub

'R}X̒̃GAI (lg̍U͈͐ݒp)
Public Sub AreaInCone(ByVal X As Integer, ByVal Y As Integer, _
    ByVal min_range As Integer, max_range As Integer, direction As String)
Dim i As Integer, j As Integer
    
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            MaskData(i, j) = True
        Next
    Next
    
    Select Case direction
        Case "N"
            For i = Y - max_range To Y - min_range
                If i >= 1 Then
                    MaskData(X, i) = False
                End If
            Next
            For i = Y - max_range + 1 To Y - (min_range + 1)
                If i >= 1 Then
                    If X > 1 Then
                        MaskData(X - 1, i) = False
                    End If
                    If X < MapWidth Then
                        MaskData(X + 1, i) = False
                    End If
                End If
            Next
            
        Case "S"
            For i = Y + min_range To Y + max_range
                If i <= MapHeight Then
                    MaskData(X, i) = False
                End If
            Next
            For i = Y + (min_range + 1) To Y + max_range - 1
                If i <= MapHeight Then
                    If X > 1 Then
                        MaskData(X - 1, i) = False
                    End If
                    If X < MapWidth Then
                        MaskData(X + 1, i) = False
                    End If
                End If
            Next
            
        Case "W"
            For i = X - max_range To X - min_range
                If i >= 1 Then
                    MaskData(i, Y) = False
                End If
            Next
            For i = X - max_range + 1 To X - (min_range + 1)
                If i >= 1 Then
                    If Y > 1 Then
                        MaskData(i, Y - 1) = False
                    End If
                    If Y < MapHeight Then
                        MaskData(i, Y + 1) = False
                    End If
                End If
            Next
            
        Case "E"
            For i = X + min_range To X + max_range
                If i <= MapWidth Then
                    MaskData(i, Y) = False
                End If
            Next
            For i = X + (min_range + 1) To X + max_range - 1
                If i <= MapWidth Then
                    If Y > 1 Then
                        MaskData(i, Y - 1) = False
                    End If
                    If Y < MapHeight Then
                        MaskData(i, Y + 1) = False
                    End If
                End If
            Next
    End Select
    
    MaskData(X, Y) = False
End Sub

'̃GAI (l̍U͈͐ݒp)
Public Sub AreaInSector(ByVal X As Integer, ByVal Y As Integer, _
    ByVal min_range As Integer, max_range As Integer, direction As String, _
    ByVal lv As Integer, Optional ByVal without_refresh As Boolean)
Dim i As Integer, xx As Integer, yy As Integer
    
    If Not without_refresh Then
        For xx = 1 To MapWidth
            For yy = 1 To MapHeight
                MaskData(xx, yy) = True
            Next
        Next
    End If
    
    Select Case direction
        Case "N"
            For i = min_range To max_range
                yy = Y - i
                If yy < 1 Then
                    Exit For
                End If
                Select Case lv
                    Case 1
                        For xx = MaxLng(X - i \ 3, 1) To MinLng(X + i \ 3, MapWidth)
                            MaskData(xx, yy) = False
                        Next
                    Case 2
                        For xx = MaxLng(X - i \ 2, 1) To MinLng(X + i \ 2, MapWidth)
                            MaskData(xx, yy) = False
                        Next
                    Case 3
                        For xx = MaxLng(X - (i - 1), 1) To MinLng(X + (i - 1), MapWidth)
                            MaskData(xx, yy) = False
                        Next
                    Case 4
                        For xx = MaxLng(X - i, 1) To MinLng(X + i, MapWidth)
                            MaskData(xx, yy) = False
                        Next
                End Select
            Next
            
        Case "S"
            For i = min_range To max_range
                yy = Y + i
                If yy > MapHeight Then
                    Exit For
                End If
                Select Case lv
                    Case 1
                        For xx = MaxLng(X - i \ 3, 1) To MinLng(X + i \ 3, MapWidth)
                            MaskData(xx, yy) = False
                        Next
                    Case 2
                        For xx = MaxLng(X - i \ 2, 1) To MinLng(X + i \ 2, MapWidth)
                            MaskData(xx, yy) = False
                        Next
                    Case 3
                        For xx = MaxLng(X - (i - 1), 1) To MinLng(X + (i - 1), MapWidth)
                            MaskData(xx, yy) = False
                        Next
                    Case 4
                        For xx = MaxLng(X - i, 1) To MinLng(X + i, MapWidth)
                            MaskData(xx, yy) = False
                        Next
                End Select
            Next
            
        Case "W"
            For i = min_range To max_range
                xx = X - i
                If xx < 1 Then
                    Exit For
                End If
                Select Case lv
                    Case 1
                        For yy = MaxLng(Y - i \ 3, 1) To MinLng(Y + i \ 3, MapHeight)
                            MaskData(xx, yy) = False
                        Next
                    Case 2
                        For yy = MaxLng(Y - i \ 2, 1) To MinLng(Y + i \ 2, MapHeight)
                            MaskData(xx, yy) = False
                        Next
                    Case 3
                        For yy = MaxLng(Y - (i - 1), 1) To MinLng(Y + (i - 1), MapHeight)
                            MaskData(xx, yy) = False
                        Next
                    Case 4
                        For yy = MaxLng(Y - i, 1) To MinLng(Y + i, MapHeight)
                            MaskData(xx, yy) = False
                        Next
                End Select
            Next
            
        Case "E"
            For i = min_range To max_range
                xx = X + i
                If xx > MapWidth Then
                    Exit For
                End If
                Select Case lv
                    Case 1
                        For yy = MaxLng(Y - i \ 3, 1) To MinLng(Y + i \ 3, MapHeight)
                            MaskData(xx, yy) = False
                        Next
                    Case 2
                        For yy = MaxLng(Y - i \ 2, 1) To MinLng(Y + i \ 2, MapHeight)
                            MaskData(xx, yy) = False
                        Next
                    Case 3
                        For yy = MaxLng(Y - (i - 1), 1) To MinLng(Y + (i - 1), MapHeight)
                            MaskData(xx, yy) = False
                        Next
                    Case 4
                        For yy = MaxLng(Y - i, 1) To MinLng(Y + i, MapHeight)
                            MaskData(xx, yy) = False
                        Next
                End Select
            Next
    End Select
    
    MaskData(X, Y) = False
End Sub

'\̐̃GAI (l̍UIp)
Public Sub AreaInSectorCross(ByVal X As Integer, ByVal Y As Integer, _
    ByVal min_range As Integer, max_range As Integer, ByVal lv As Integer)
Dim xx As Integer, yy As Integer
    
    For xx = 1 To MapWidth
        For yy = 1 To MapHeight
            MaskData(xx, yy) = True
        Next
    Next
    
    AreaInSector X, Y, min_range, max_range, "N", lv, True
    AreaInSector X, Y, min_range, max_range, "S", lv, True
    AreaInSector X, Y, min_range, max_range, "W", lv, True
    AreaInSector X, Y, min_range, max_range, "E", lv, True
End Sub

'Q_ԂԒ̃GAI (l͈̔͐ݒp)
Public Sub AreaInPointToPoint(ByVal x1 As Integer, ByVal y1 As Integer, _
    ByVal x2 As Integer, ByVal y2 As Integer)
Dim xx As Integer, yy As Integer

    '܂S̈}XN
    For xx = 1 To MapWidth
        For yy = 1 To MapHeight
            MaskData(xx, yy) = True
        Next
    Next
    
    'N_̃}XN
    MaskData(x1, y1) = False
    
    xx = x1
    yy = y1
    If Abs(x1 - x2) > Abs(y1 - y2) Then
         Do
             If x1 > x2 Then
                 xx = xx - 1
             Else
                 xx = xx + 1
             End If
             MaskData(xx, yy) = False
             yy = y1 + (y2 - y1) * (x1 - xx + 0#) / (x1 - x2)
             MaskData(xx, yy) = False
         Loop Until xx = x2
    Else
         Do
             If y1 > y2 Then
                 yy = yy - 1
             Else
                 yy = yy + 1
             End If
             MaskData(xx, yy) = False
             xx = x1 + (x2 - x1) * (y1 - yy + 0#) / (y1 - y2)
             MaskData(xx, yy) = False
         Loop Until yy = y2
    End If
End Sub

'jbg u ̈ړ͈͂I
'Wvꍇ ByJump = True
Public Sub AreaInSpeed(u As Unit, Optional ByVal ByJump As Boolean)
Dim i As Integer, j As Integer, k As Integer, l As Integer, n As Integer
Dim cur_cost(0 To 51, 0 To 51) As Long
Dim move_cost(0 To 51, 0 To 51) As Long
Dim move_area As String
Dim tmp As Long, buf As String
Dim is_trans_available_on_ground As Boolean
Dim is_trans_available_in_water As Boolean
Dim is_trans_available_on_water As Boolean
Dim is_trans_available_in_sky As Boolean
Dim is_trans_available_in_moon_sky As Boolean
Dim is_adaptable_in_water As Boolean
Dim is_adaptable_in_space As Boolean
Dim is_swimable As Boolean
Dim adopted_terrain() As String
Dim allowed_terrains() As String
Dim prohibited_terrains() As String
Dim uspeed As Integer
Dim u2 As Unit
Dim x1 As Integer, y1 As Integer
Dim x2 As Integer, y2 As Integer
Dim zarea As Integer
Dim is_zoc As Boolean
Dim is_vzoc As Boolean, is_hzoc As Boolean
' ADD START MARGE
Dim td As TerrainData
Dim is_terrain_effective As Boolean
' ADD END MARGE

    With u
        'ړɎgpGA
        If ByJump Then
            move_area = ""
        Else
            move_area = .Area
        End If
        
        'ړ\͂̉ۂ𒲂ׂĂ
        is_trans_available_on_ground = .IsTransAvailable("") And .Adaption(2) <> 0
        is_trans_available_in_water = .IsTransAvailable("") And .Adaption(3) <> 0
        is_trans_available_in_sky = .IsTransAvailable("") And .Adaption(1) <> 0
        is_trans_available_in_moon_sky = (.IsTransAvailable("") And .Adaption(1) <> 0) _
            Or (.IsTransAvailable("F") And .Adaption(4) <> 0)
        If Mid$(.Data.Adaption, 3, 1) <> "-" _
            Or .IsFeatureAvailable("ړ") _
        Then
            is_adaptable_in_water = True
        End If
        If Mid$(.Data.Adaption, 4, 1) <> "-" _
            Or .IsFeatureAvailable("Fړ") _
        Then
            is_adaptable_in_space = True
        End If
        If .IsFeatureAvailable("ړ") _
            Or .IsFeatureAvailable("zo[ړ") _
        Then
            is_trans_available_on_water = True
        End If
        If .IsFeatureAvailable("j") Then
            is_swimable = True
        End If
        
        'n`K̂n`̃Xg쐬
        ReDim adopted_terrain(0)
        If .IsFeatureAvailable("n`K") Then
            For i = 1 To .CountFeature
                If .Feature(i) = "n`K" Then
                    buf = .FeatureData(i)
                    If LLength(buf) = 0 Then
                        ErrorMessage "jbgu" & _
                            .Name & "v̒n`K\͂ɑΉn`w肳Ă܂"
                        TerminateSRC
                    End If
                    n = LLength(buf)
                    ReDim Preserve adopted_terrain(UBound(adopted_terrain) + n - 1)
                    For j = 2 To n
                        adopted_terrain(UBound(adopted_terrain) - j + 2) = LIndex(buf, j)
                    Next
                End If
            Next
        End If
        
        'ړ
        If ByJump Then
            uspeed = .Speed + .FeatureLevel("Wv")
        Else
            uspeed = .Speed
        End If
        If .IsConditionSatisfied("ړs\") Then
            uspeed = 0
        End If
        
        'ړRXg͎ۂ̂Q{̒lŋL^Ă邽߁Aړ͂ɍ킹
        'Q{ɂĈړ͈͂vZ
        uspeed = 2 * uspeed
        
' ADD START MARGE
        'Ĉړ͍ŏ̈ړ̕ړ͂
        If SelectedCommand = "Ĉړ" Then
            uspeed = uspeed - SelectedUnitMoveCost
        End If
        
        If .IsConditionSatisfied("ړs\") Then
            uspeed = 0
        End If
' ADD END MARGE
        
        'ړ͈͂`FbNׂ̈
        x1 = MaxLng(1, .X - uspeed)
        y1 = MaxLng(1, .Y - uspeed)
        x2 = MinLng(.X + uspeed, MapWidth)
        y2 = MinLng(.Y + uspeed, MapHeight)
        
        'ړRXgƂynbZbg
        For i = 0 To MapWidth + 1
            For j = 0 To MapHeight + 1
                move_cost(i, j) = 1000000
                PointInZOC(i, j) = 0
            Next
        Next
        
        'en`̈ړRXgZoĂ
        Select Case move_area
            Case ""
                For i = x1 To x2
                    For j = y1 To y2
                        Select Case TerrainClass(i, j)
                            Case ""
                                move_cost(i, j) = TerrainMoveCost(i, j)
                            Case "F"
                                If is_adaptable_in_space Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case Else
                                move_cost(i, j) = MinLng(move_cost(i, j), 2)
                        End Select
                    Next
                Next
            Case "n"
                For i = x1 To x2
                    For j = y1 To y2
                        Select Case TerrainClass(i, j)
                            Case "", "", ""
                                If is_trans_available_on_ground Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                         End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case ""
                                If is_trans_available_in_water _
                                    Or is_trans_available_on_water _
                                Then
                                    move_cost(i, j) = 2
                                ElseIf is_adaptable_in_water Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case "["
                                If is_trans_available_in_water _
                                    Or is_trans_available_on_water _
                                Then
                                    move_cost(i, j) = 2
                                ElseIf is_swimable Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case ""
                                move_cost(i, j) = 1000000
                            Case "F"
                                If is_adaptable_in_space Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                        End Select
                    Next
                Next
            Case ""
                For i = x1 To x2
                    For j = y1 To y2
                        Select Case TerrainClass(i, j)
                            Case "", "", ""
                                If is_trans_available_on_ground Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case "", "["
                               move_cost(i, j) = 2
                            Case ""
                               move_cost(i, j) = 1000000
                            Case "F"
                                If is_adaptable_in_space Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                        End Select
                    Next
                Next
            Case ""
                For i = x1 To x2
                    For j = y1 To y2
                        Select Case TerrainClass(i, j)
                            Case "", "", ""
                                If is_trans_available_on_ground Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case ""
                                If is_trans_available_in_water Then
                                    move_cost(i, j) = 2
                                Else
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                End If
                            Case "["
                                If is_trans_available_in_water Then
                                    move_cost(i, j) = 2
                                ElseIf is_swimable Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case ""
                                move_cost(i, j) = 1000000
                            Case "F"
                                If is_adaptable_in_space Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                        End Select
                    Next
                Next
            Case "F"
                For i = x1 To x2
                    For j = y1 To y2
                        Select Case TerrainClass(i, j)
                            Case "F"
                                move_cost(i, j) = TerrainMoveCost(i, j)
                                For k = 1 To UBound(adopted_terrain)
                                    If TerrainName(i, j) = adopted_terrain(k) Then
                                        move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                        Exit For
                                    End If
                                Next
                            Case "", ""
                                If is_trans_available_in_sky Then
                                    move_cost(i, j) = 2
                                ElseIf is_trans_available_on_ground Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                         End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case ""
                                If is_trans_available_in_moon_sky Then
                                    move_cost(i, j) = 2
                                ElseIf is_trans_available_on_ground Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                         End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case ""
                                If is_trans_available_in_water _
                                    Or is_trans_available_on_water _
                                Then
                                    move_cost(i, j) = 2
                                ElseIf is_adaptable_in_water Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case "["
                                If is_trans_available_in_water _
                                    Or is_trans_available_on_water _
                                Then
                                    move_cost(i, j) = 2
                                ElseIf is_swimable Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                            Case ""
                                If is_trans_available_in_sky Then
                                    move_cost(i, j) = TerrainMoveCost(i, j)
                                    For k = 1 To UBound(adopted_terrain)
                                        If TerrainName(i, j) = adopted_terrain(k) Then
                                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                            Exit For
                                        End If
                                    Next
                                Else
                                    move_cost(i, j) = 1000000
                                End If
                        End Select
                    Next
                Next
            Case "n"
                For i = x1 To x2
                    For j = y1 To y2
                        Select Case TerrainClass(i, j)
                            Case "", ""
                                move_cost(i, j) = 2
                            Case Else
                                move_cost(i, j) = 1000000
                        End Select
                    Next
                Next
        End Select
        
        'Hړ
        If .IsFeatureAvailable("Hړ") Then
            If .Area = "n" And Not ByJump Then
                For i = x1 To x2
                    For j = y1 To y2
                        If TerrainName(i, j) = "H" Then
                            move_cost(i, j) = 2
                        Else
                            move_cost(i, j) = 1000000
                        End If
                    Next
                Next
            End If
        End If
        
        'ړ
        ReDim allowed_terrains(0)
        If .IsFeatureAvailable("ړ") Then
            If .Area <> "" And .Area <> "n" Then
                n = LLength(.FeatureData("ړ"))
                ReDim allowed_terrains(n)
                For i = 2 To n
                    allowed_terrains(i) = LIndex(.FeatureData("ړ"), i)
                Next
                If Not ByJump Then
                    For i = x1 To x2
                        For j = y1 To y2
                            For k = 2 To n
                                If TerrainName(i, j) = allowed_terrains(k) Then
                                    Exit For
                                End If
                            Next
                            If k > n Then
                                move_cost(i, j) = 1000000
                            End If
                        Next
                    Next
                End If
            End If
        End If
        
        'is
        ReDim prohibited_terrains(0)
        If .IsFeatureAvailable("is") Then
            If .Area <> "" And .Area <> "n" Then
                n = LLength(.FeatureData("is"))
                ReDim prohibited_terrains(n)
                For i = 2 To n
                    prohibited_terrains(i) = LIndex(.FeatureData("is"), i)
                Next
                If Not ByJump Then
                    For i = x1 To x2
                        For j = y1 To y2
                            For k = 2 To n
                                If TerrainName(i, j) = prohibited_terrains(k) Then
                                    move_cost(i, j) = 1000000
                                    Exit For
                                End If
                            Next
                        Next
                    Next
                End If
            End If
        End If
        
        'zo[ړ
        If .IsFeatureAvailable("zo[ړ") Then
            If move_area = "n" Or move_area = "" Then
                For i = x1 To x2
                    For j = y1 To y2
                        Select Case TerrainName(i, j)
                            Case "", "ጴ"
                                move_cost(i, j) = 2
                        End Select
                    Next
                Next
            End If
        End If
        
        '߈ړ
        If .IsFeatureAvailable("߈ړ") _
            Or .IsUnderSpecialPowerEffect("߈ړ") _
        Then
            For i = x1 To x2
                For j = y1 To y2
                    move_cost(i, j) = 2
                Next
            Next
        End If
        
        'jbg邽ߒʂ蔲oȂꏊ`FbN
        If Not .IsFeatureAvailable("蔲ړ") _
            And Not .IsUnderSpecialPowerEffect("蔲ړ") _
        Then
            For Each u2 In UList
                With u2
                    If .Status = "o" Then
                        Dim blocked As Boolean
                        
                        blocked = False
                        
                        'G΂ꍇ͒ʂ蔲s
                        If .IsEnemy(u, True) Then
                            blocked = True
                        End If
                        
                        'wcȂꍇʂ蔲s
                        Select Case .Party0
                            Case "", "mob"
                                If u.Party0 <> "" _
                                    And u.Party0 <> "mob" _
                                Then
                                    blocked = True
                                End If
                            Case Else
                                If .Party0 <> u.Party0 Then
                                    blocked = True
                                End If
                        End Select
                        
                        'ʂ蔲Ȃꍇ
                        If blocked Then
                            move_cost(.X, .Y) = 1000000
                        End If
                        
                        'ynb
                        If blocked And Not ByJump Then
                            is_zoc = False
                            zarea = 0
                            If .IsFeatureAvailable("ynb") _
                                Or IsOptionDefined("ynb") _
                            Then
                                is_zoc = True
                                zarea = 1
                                
                                'ynb̂ynbx
                                n = .FeatureLevel("ynb")
                                If n = 1 Then n = 10000
                                
                                'Optionuynbvw肳Ă
                                n = MaxLng(1, n)
                                
                                If u.IsFeatureAvailable("ynb") Then
                                    'ړ̂ynbx
                                    'xwȂA܂Lv1Lv10000ƂĈ
                                    l = u.FeatureLevel("ynb")
                                    If l = 1 Then l = 10000
                                    
                                    'ړ̂ynbx̕ꍇA
                                    'ynbs\
                                    If l >= n Then
                                        is_zoc = False
                                    End If
                                End If
                                
                                'אڂ郆jbguאڃjbgynbvĂꍇ
                                If is_zoc Then
                                    For i = -1 To 1
                                        For j = Abs(i) - 1 To Abs(Abs(i) - 1)
                                            If (i <> 0 Or j <> 0) _
                                                And ((.X + i) >= 1 And (.X + i) <= MapWidth _
                                                    And (.Y + j) >= 1 And (.Y + j) <= MapHeight) _
                                            Then
                                                'אڃjbg݂H
                                                If Not MapDataForUnit(.X + i, .Y + j) Is Nothing Then
                                                    buf = .Party0
                                                    With MapDataForUnit(.X + i, .Y + j)
                                                        'GΐwcH
                                                        Select Case .Party0
                                                            Case "", "mob"
                                                                If buf = "" _
                                                                    Or buf = "mob" _
                                                                Then
                                                                    Exit For
                                                                End If
                                                            Case Else
                                                                If .Party0 = buf Then
                                                                    Exit For
                                                                End If
                                                        End Select
                                                        
                                                        l = .FeatureLevel("אڃjbgynb")
                                                        If l = 1 Then l = 10000
                                                        
                                                        'ړ̂ynbx̕ꍇA
                                                        'ynbs\
                                                        If l >= n Then
                                                            is_zoc = False
                                                            Exit For
                                                        End If
                                                    End With
                                                End If
                                            End If
                                        Next
                                    Next
                                End If
                            End If
                            
                            If is_zoc Then
                                '\́uynbvw肳ĂȂÃf[^2ڂ̒lynb͈̔͂ɐݒ
                                '2ڂ̒lȗĂꍇ1ݒ
                                'ynbLv0ȉ̏ꍇAIvVuynbvw肳ĂĂ͈͂0ɐݒ
                                If LLength(.FeatureData("ynb")) >= 2 Then
                                    zarea = MaxLng(LIndex(.FeatureData("ynb"), 2), 0)
                                End If
                                
                                '΋{ynb͈̔͂ړ͈ȓ̂ƂAynbݒ
                                If Abs(u.X - .X) + Abs(u.Y - .Y) - zarea <= uspeed Then
                                    'Ê݂̂ynbǂ𔻒f
                                    is_hzoc = False
                                    is_vzoc = False
                                    If InStr(.FeatureData("ynb"), "") Then
                                        is_hzoc = True
                                        is_vzoc = True
                                    Else
                                        If InStr(.FeatureData("ynb"), "") Then
                                            is_hzoc = True
                                        End If
                                        If InStr(.FeatureData("ynb"), "") Then
                                            is_vzoc = True
                                        End If
                                    End If
                                    
                                    If is_hzoc Or is_vzoc Then
                                        For i = (zarea * -1) To zarea
                                            If i = 0 Then
                                                If PointInZOC(.X, .Y) < 0 Then
                                                    If n > Abs(PointInZOC(.X, .Y)) Then
                                                        PointInZOC(.X, .Y) = n
                                                    End If
                                                Else
                                                    PointInZOC(.X, .Y) = MaxLng(n, PointInZOC(.X, .Y))
                                                End If
                                            Else
                                                'ynb
                                                If is_hzoc And (.X + i) >= 1 And (.X + i) <= MapWidth Then
                                                    If PointInZOC(.X + i, .Y) < 0 Then
                                                        If n > Abs(PointInZOC(.X + i, .Y)) Then
                                                            PointInZOC(.X + i, .Y) = n
                                                        End If
                                                    Else
                                                        PointInZOC(.X + i, .Y) = MaxLng(n, PointInZOC(.X + i, .Y))
                                                    End If
                                                End If
                                                'ynb
                                                If is_vzoc And (.Y + i) >= 1 And (.Y + i) <= MapHeight Then
                                                    If PointInZOC(.X, .Y + i) < 0 Then
                                                        If n > Abs(PointInZOC(.X, .Y + i)) Then
                                                            PointInZOC(.X, .Y + i) = n
                                                        End If
                                                    Else
                                                        PointInZOC(.X, .Y + i) = MaxLng(n, PointInZOC(.X, .Y + i))
                                                    End If
                                                End If
                                            End If
                                        Next
                                    Else
                                        'Sʂynb
                                        For i = (zarea * -1) To zarea
                                            For j = (Abs(i) - zarea) To Abs(Abs(i) - zarea)
                                                If (.X + i) >= 1 And (.X + i) <= MapWidth _
                                                    And (.Y + j) >= 1 And (.Y + j) <= MapHeight _
                                                Then
                                                    If PointInZOC(.X + i, .Y + j) < 0 Then
                                                        If n > Abs(PointInZOC(.X + i, .Y + j)) Then
                                                            PointInZOC(.X + i, .Y + j) = n
                                                        End If
                                                    Else
                                                        PointInZOC(.X + i, .Y + j) = MaxLng(n, PointInZOC(.X + i, .Y + j))
                                                    End If
                                                End If
                                            Next
                                        Next
                                    End If
                                End If
                            End If
                        Else
                            'uLynbvĂꍇ̏
                            If Abs(u.X - .X) + Abs(u.Y - .Y) - zarea <= uspeed Then
                                'xwȂA܂Lv1Lv10000ƂĈ
                                l = .FeatureLevel("Lynb")
                                If l = 1 Then l = 10000
                                
                                If l > 0 Then
                                    n = MaxLng(StrToLng(LIndex(.FeatureData("Lynb"), 2)), 1)
                                    
                                    For i = (n * -1) To n
                                        For j = (Abs(i) - n) To Abs(Abs(i) - n)
                                            If (.X + i) >= 1 And (.X + i) <= MapWidth _
                                                And (.Y + j) >= 1 And (.Y + j) <= MapHeight _
                                            Then
                                                PointInZOC(.X + i, .Y + j) = PointInZOC(.X + i, .Y + j) - l
                                            End If
                                        Next
                                    Next
                                End If
                            End If
                        End If
                    End If
                End With
            Next
        End If
        
        'ړ~n`͂ynbĈ
        If Not ByJump Then
            With TDList
                For i = x1 To x2
                    For j = y1 To y2
'MOD START 240a
'                        If .IsFeatureAvailable(MapData(i, j, 0), "ړ~") Then
'                            PointInZOC(i, j) = 20000
'                        End If
                        If TerrainHasMoveStop(i, j) Then
                            PointInZOC(i, j) = 20000
                        End If
'MOD  END  240a
                    Next
                Next
            End With
        End If
        
        '}bv̊en_ɓB̂ɕKvȈړ͂vZ
        
        '܂ړRXgvZp̔z
        For i = 0 To MapWidth + 1
            For j = 0 To MapHeight + 1
                TotalMoveCost(i, j) = 1000000
            Next
        Next
        
        '݂ꏊ͈ړKvȂ߁AKvړ͂0
        TotalMoveCost(.X, .Y) = 0
        
        'Kvړ͂̌vZ
        For i = 1 To uspeed
            '݂̕Kvړ͂ۑ
            For j = MaxLng(0, .X - i - 1) To MinLng(.X + i + 1, MapWidth + 1)
                For k = MaxLng(0, .Y - i - 1) To MinLng(.Y + i + 1, MapHeight + 1)
                    cur_cost(j, k) = TotalMoveCost(j, k)
                Next
            Next
            For j = MaxLng(1, .X - i) To MinLng(.X + i, MapWidth)
                For k = MaxLng(1, .Y - i) To MinLng(.Y + i, MapHeight)
                    'אڂn_ƔrčłႢKvړ͂߂
                    tmp = cur_cost(j, k)
                    If i > 1 Then
                        With TDList
                            tmp = MinLng(tmp, cur_cost(j - 1, k) + IIf(PointInZOC(j - 1, k) > 0, 10000, 0))
                            tmp = MinLng(tmp, cur_cost(j + 1, k) + IIf(PointInZOC(j + 1, k) > 0, 10000, 0))
                            tmp = MinLng(tmp, cur_cost(j, k - 1) + IIf(PointInZOC(j, k - 1) > 0, 10000, 0))
                            tmp = MinLng(tmp, cur_cost(j, k + 1) + IIf(PointInZOC(j, k + 1) > 0, 10000, 0))
                        End With
                    Else
                        tmp = MinLng(tmp, cur_cost(j - 1, k))
                        tmp = MinLng(tmp, cur_cost(j + 1, k))
                        tmp = MinLng(tmp, cur_cost(j, k - 1))
                        tmp = MinLng(tmp, cur_cost(j, k + 1))
                    End If
                    'n`ɐîɕKvȈړ͂Z
                    tmp = tmp + move_cost(j, k)
                    'O̒lƂǂ炪ႢH
                    TotalMoveCost(j, k) = MinLng(tmp, cur_cost(j, k))
                Next
            Next
        Next
        
        'ZoꂽKvړ͂ɐi\
         For i = 1 To MapWidth
             For j = 1 To MapHeight
                MaskData(i, j) = True
                
                'Kvړ͂ړ͈ȓH
                If TotalMoveCost(i, j) > uspeed Then
                    GoTo NextLoop
                End If
                
                Set u2 = MapDataForUnit(i, j)
                
                'jbg݁H
                If u2 Is Nothing Then
                    MaskData(i, j) = False
                    GoTo NextLoop
                End If
                
                '͖́͂̂̂
                If .Party0 <> "" Then
                    GoTo NextLoop
                End If
                
                Select Case u2.Party0
                    Case ""
                        If u2.IsFeatureAvailable("") Then
                            '͂ɒ́H
                            If Not .IsFeatureAvailable("") _
                                And u2.Area <> "n" _
                            Then
                                If Not .IsFeatureAvailable("i[s") Then
                                    MaskData(i, j) = False
                                End If
                            End If
                        ElseIf .IsFeatureAvailable("") _
                            And u2.IsFeatureAvailable("") _
                        Then
                            'Q̍́H
                            MaskData(i, j) = True
                            For k = 1 To .CountFeature
                                If .Feature(k) = "" And .FeatureName(k) <> "" Then
                                    buf = .FeatureData(k)
                                    If LLength(buf) = 3 _
                                        And UList.IsDefined(LIndex(buf, 2)) _
                                        And UList.IsDefined(LIndex(buf, 3)) _
                                    Then
                                        With UList.Item(LIndex(buf, 2))
                                            If .IsConditionSatisfied("ss\") Then
                                                Exit For
                                            End If
                                            If .Status = "j" Then
                                                Exit For
                                            End If
                                        End With
                                        If u2.Name = LIndex(buf, 3) Then
                                            MaskData(i, j) = False
                                            Exit For
                                        ElseIf u2.Name = _
                                                UList.Item(LIndex(buf, 3)).CurrentForm.Name _
                                            And Not u2.IsFeatureAvailable("̐") _
                                        Then
                                            MaskData(i, j) = False
                                            Exit For
                                        End If
                                    End If
                                End If
                            Next
                        End If
                    Case "mob"
                        If .IsFeatureAvailable("") _
                            And u2.IsFeatureAvailable("") _
                        Then
                            'Q̍́H
                            MaskData(i, j) = True
                            For k = 1 To .CountFeature
                                If .Feature(k) = "" Then
                                    buf = .FeatureData(k)
                                    If LLength(buf) = 3 _
                                        And UList.IsDefined(LIndex(buf, 2)) _
                                        And UList.IsDefined(LIndex(buf, 3)) _
                                    Then
                                        With UList.Item(LIndex(buf, 2))
                                            If .IsConditionSatisfied("ss\") Then
                                                Exit For
                                            End If
                                            If .Status = "j" Then
                                                Exit For
                                            End If
                                        End With
                                        If u2.Name = LIndex(buf, 3) Then
                                            MaskData(i, j) = False
                                            Exit For
                                        ElseIf u2.Name = _
                                                UList.Item(LIndex(buf, 3)).CurrentForm.Name _
                                            And Not u2.IsFeatureAvailable("̐") _
                                        Then
                                            MaskData(i, j) = False
                                            Exit For
                                        End If
                                    End If
                                End If
                            Next
                        End If
                End Select
NextLoop:
            Next
        Next
        
        'Wv߈ړ͐i\H
        If ByJump _
            Or .IsFeatureAvailable("߈ړ") _
            Or .IsUnderSpecialPowerEffect("߈ړ") _
        Then
            For i = x1 To x2
                For j = y1 To y2
                    If MaskData(i, j) Then
                        GoTo NextLoop2
                    End If
                    
                    'jbgn`ɐioƂƂ
                    'or͉\ƂƂȂ̂Œn`͖
                    If Not MapDataForUnit(i, j) Is Nothing Then
                        GoTo NextLoop2
                    End If
                    
                    Select Case .Area
                        Case "n"
                            Select Case TerrainClass(i, j)
                                Case ""
                                    MaskData(i, j) = True
                                Case ""
                                    If Not is_adaptable_in_water _
                                        And Not is_trans_available_on_water _
                                        And Not is_trans_available_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case "["
                                    If Not is_trans_available_on_water _
                                        And Not is_trans_available_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case "F"
                                    If Not is_adaptable_in_space Then
                                        MaskData(i, j) = True
                                    End If
                            End Select
                        Case ""
                            Select Case TerrainClass(i, j)
                                Case ""
                                    MaskData(i, j) = True
                                Case "F"
                                    If Not is_adaptable_in_space Then
                                        MaskData(i, j) = True
                                    End If
                            End Select
                        Case ""
                            Select Case TerrainClass(i, j)
                                Case ""
                                    MaskData(i, j) = True
                                Case "["
                                    If Not is_trans_available_on_water _
                                        And Not is_trans_available_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case "F"
                                    If Not is_adaptable_in_space Then
                                        MaskData(i, j) = True
                                    End If
                            End Select
                        Case ""
                            Select Case TerrainClass(i, j)
                                Case ""
                                    If TerrainMoveCost(i, j) > 100 Then
                                        MaskData(i, j) = True
                                    End If
                                Case "F"
                                    If Not is_adaptable_in_space Then
                                        MaskData(i, j) = True
                                    End If
                            End Select
                        Case "n"
                            If TerrainClass(i, j) <> "" Then
                                MaskData(i, j) = True
                            End If
                        Case "F"
                            Select Case TerrainClass(i, j)
                                Case "", ""
                                    If Not is_trans_available_in_sky _
                                        And Not is_trans_available_on_ground _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case ""
                                    If Not is_trans_available_in_sky _
                                        Or TerrainMoveCost(i, j) > 10 _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case ""
                                    If Not is_trans_available_in_water _
                                        And Not is_trans_available_on_water _
                                        And Not is_adaptable_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case "["
                                    If Not is_trans_available_on_water _
                                        And Not is_trans_available_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                            End Select
                    End Select
                    
                    'ړ
                    If UBound(allowed_terrains) > 0 Then
                        For k = 2 To UBound(allowed_terrains)
                            If TerrainName(i, j) = allowed_terrains(k) Then
                                Exit For
                            End If
                        Next
                        If k > UBound(allowed_terrains) Then
                            MaskData(i, j) = True
                        End If
                    End If
                    
                    'is
                    For k = 2 To UBound(prohibited_terrains)
                        If TerrainName(i, j) = prohibited_terrains(k) Then
                            MaskData(i, j) = True
                            Exit For
                        End If
                    Next
NextLoop2:
                Next
            Next
        End If
        
        '݂ꏊ͏ɐi\
        MaskData(.X, .Y) = False
    End With
End Sub

'jbg u e|[gĈړł͈͂I
'ő勗 lv w\B(ȗ͈ړ́{e|[gx)
Public Sub AreaInTeleport(u As Unit, Optional ByVal lv As Integer)
Dim is_trans_available_on_ground As Boolean
Dim is_trans_available_in_water As Boolean
Dim is_trans_available_on_water As Boolean
Dim is_trans_available_in_sky As Boolean
Dim is_adaptable_in_water As Boolean
Dim is_adaptable_in_space As Boolean
Dim allowed_terrains() As String
Dim prohibited_terrains() As String
Dim i As Integer, j As Integer, k As Integer, n As Integer, r As Integer
Dim buf As String
Dim u2 As Unit
    
    With u
        'ړ\͂̉ۂ𒲂ׂĂ
        is_trans_available_on_ground = .IsTransAvailable("") And .Adaption(2) <> 0
        is_trans_available_in_water = .IsTransAvailable("") And .Adaption(3) <> 0
        is_trans_available_in_sky = .IsTransAvailable("") And .Adaption(1) <> 0
        If Mid$(.Data.Adaption, 3, 1) <> "-" _
            Or .IsFeatureAvailable("ړ") _
        Then
            is_adaptable_in_water = True
        End If
        If Mid$(.Data.Adaption, 4, 1) <> "-" _
            Or .IsFeatureAvailable("Fړ") _
        Then
            is_adaptable_in_space = True
        End If
        If .IsFeatureAvailable("ړ") _
            Or .IsFeatureAvailable("zo[ړ") _
        Then
            is_trans_available_on_water = True
        End If
        
        'ړ
        ReDim allowed_terrains(0)
        If .IsFeatureAvailable("ړ") Then
            If .Area <> "" And .Area <> "n" Then
                n = LLength(.FeatureData("ړ"))
                ReDim allowed_terrains(n)
                For i = 2 To n
                    allowed_terrains(i) = LIndex(.FeatureData("ړ"), i)
                Next
            End If
        End If
        
        'is
        ReDim prohibited_terrains(0)
        If .IsFeatureAvailable("is") Then
            If .Area <> "" And .Area <> "n" Then
                n = LLength(.FeatureData("is"))
                ReDim prohibited_terrains(n)
                For i = 2 To n
                    prohibited_terrains(i) = LIndex(.FeatureData("is"), i)
                Next
            End If
        End If
        
        'e|[gɂړZo
        If lv > 0 Then
            r = lv
        Else
            r = .Speed + .FeatureLevel("e|[g")
        End If
        If .IsConditionSatisfied("ړs\") Then
            r = 0
        End If
        
        'I
        For i = 1 To MapWidth
            For j = 1 To MapHeight
                MaskData(i, j) = True
            Next
        Next
        
        'ړ\Ȓn_𒲂ׂ
        For i = MaxLng(1, .X - r) To MinLng(MapWidth, .X + r)
            For j = MaxLng(1, .Y - r) To MinLng(MapHeight, .Y + r)
                'ړ͈͓H
                If Abs(.X - i) + Abs(.Y - j) > r Then
                    GoTo NextLoop
                End If
                
                Set u2 = MapDataForUnit(i, j)
                
                If u2 Is Nothing Then
                    'jbgȂn_͒n`i\`FbN
                    MaskData(i, j) = False
                    Select Case .Area
                        Case "n"
                            Select Case TerrainClass(i, j)
                                Case ""
                                    MaskData(i, j) = True
                                Case ""
                                    If Not is_adaptable_in_water _
                                        And Not is_trans_available_on_water _
                                        And Not is_trans_available_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case "["
                                    If Not is_trans_available_on_water _
                                        And Not is_trans_available_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case "F"
                                    If Not is_adaptable_in_space Then
                                        MaskData(i, j) = True
                                    End If
                            End Select
                        Case ""
                            Select Case TerrainClass(i, j)
                                Case ""
                                    MaskData(i, j) = True
                                Case "["
                                    If Not is_trans_available_on_water _
                                        And Not is_trans_available_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case "F"
                                    If Not is_adaptable_in_space Then
                                        MaskData(i, j) = True
                                    End If
                            End Select
                        Case ""
                            Select Case TerrainClass(i, j)
                                Case ""
                                    If TerrainMoveCost(i, j) > 100 Then
                                        MaskData(i, j) = True
                                    End If
                                Case "F"
                                    If Not is_adaptable_in_space Then
                                        MaskData(i, j) = True
                                    End If
                            End Select
                        Case "n"
                            If TerrainClass(i, j) <> "" Then
                                MaskData(i, j) = True
                            End If
                        Case "F"
                            Select Case TerrainClass(i, j)
                                Case "", ""
                                    If Not is_trans_available_in_sky _
                                        And Not is_trans_available_on_ground _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case ""
                                    If Not is_trans_available_in_sky _
                                        Or TerrainMoveCost(i, j) > 100 _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case ""
                                    If Not is_trans_available_in_water _
                                        And Not is_trans_available_on_water _
                                        And Not is_adaptable_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                                Case "["
                                    If Not is_trans_available_on_water _
                                        And Not is_trans_available_in_water _
                                    Then
                                        MaskData(i, j) = True
                                    End If
                            End Select
                    End Select
                    
                    'ړ
                    If UBound(allowed_terrains) > 0 Then
                        For k = 2 To UBound(allowed_terrains)
                            If TerrainName(i, j) = allowed_terrains(k) Then
                                Exit For
                            End If
                        Next
                        If k > UBound(allowed_terrains) Then
                            MaskData(i, j) = True
                        End If
                    End If
                    
                    'is
                    For k = 2 To UBound(prohibited_terrains)
                        If TerrainName(i, j) = prohibited_terrains(k) Then
                            MaskData(i, j) = True
                            Exit For
                        End If
                    Next
                    
                    GoTo NextLoop
                End If
                
                '͖́͂̂̂
                If .Party0 <> "" Then
                    GoTo NextLoop
                End If
                
                Select Case u2.Party0
                    Case ""
                        If u2.IsFeatureAvailable("") Then
                            '͂ɒ́H
                            If Not .IsFeatureAvailable("") _
                                And Not .IsFeatureAvailable("i[s") _
                                And u2.Area <> "n" _
                                And Not u2.IsDisabled("") _
                            Then
                                MaskData(i, j) = False
                            End If
                        ElseIf .IsFeatureAvailable("") _
                            And u2.IsFeatureAvailable("") _
                        Then
                            'Q̍́H
                            MaskData(i, j) = True
                            For k = 1 To .CountFeature
                                If .Feature(k) = "" And .FeatureName(k) <> "" Then
                                    buf = .FeatureData(k)
                                    If LLength(buf) = 3 _
                                        And UList.IsDefined(LIndex(buf, 2)) _
                                        And UList.IsDefined(LIndex(buf, 3)) _
                                    Then
                                        With UList.Item(LIndex(buf, 2))
                                            If .IsConditionSatisfied("ss\") Then
                                                Exit For
                                            End If
                                            If .Status = "j" Then
                                                Exit For
                                            End If
                                        End With
                                        If u2.Name = LIndex(buf, 3) Then
                                            MaskData(i, j) = False
                                            Exit For
                                        ElseIf u2.Name = _
                                                UList.Item(LIndex(buf, 3)).CurrentForm.Name _
                                            And Not u2.IsFeatureAvailable("̐") _
                                        Then
                                            MaskData(i, j) = False
                                            Exit For
                                        End If
                                    End If
                                End If
                            Next
                        End If
                    Case "mob"
                        If .IsFeatureAvailable("") _
                            And u2.IsFeatureAvailable("") _
                        Then
                            'Q̍́H
                            MaskData(i, j) = True
                            For k = 1 To .CountFeature
                                If .Feature(k) = "" Then
                                    buf = .FeatureData(k)
                                    If LLength(buf) = 3 _
                                        And UList.IsDefined(LIndex(buf, 2)) _
                                        And UList.IsDefined(LIndex(buf, 3)) _
                                    Then
                                        With UList.Item(LIndex(buf, 2))
                                            If .IsConditionSatisfied("ss\") Then
                                                Exit For
                                            End If
                                            If .Status = "j" Then
                                                Exit For
                                            End If
                                        End With
                                        If u2.Name = LIndex(buf, 3) Then
                                            MaskData(i, j) = False
                                            Exit For
                                        ElseIf u2.Name = _
                                                UList.Item(LIndex(buf, 3)).CurrentForm.Name _
                                            And Not u2.IsFeatureAvailable("̐") _
                                        Then
                                            MaskData(i, j) = False
                                            Exit For
                                        End If
                                    End If
                                End If
                            Next
                        End If
                End Select
NextLoop:
            Next
        Next
        
        '݂ꏊ͏ɐi\
        MaskData(.X, .Y) = False
    End With
End Sub

'jbg u ̂lڕAAreB̃^[QbgWIp
Public Sub AreaInMoveAction(u As Unit, ByVal max_range As Integer)
Dim i As Integer, j As Integer, k As Integer, n As Integer
' ADD START MARGE
Dim buf As String
' ADD END MARGE
Dim is_trans_available_on_ground As Boolean
Dim is_trans_available_in_water As Boolean
Dim is_trans_available_on_water As Boolean
Dim is_trans_available_in_sky As Boolean
Dim is_adaptable_in_water As Boolean
Dim is_adaptable_in_space As Boolean
Dim is_able_to_penetrate As Boolean
' ADD START MARGE
Dim adopted_terrain() As String
' ADD END MARGE
Dim allowed_terrains() As String
Dim prohibited_terrains() As String
Dim x1 As Integer, y1 As Integer
Dim x2 As Integer, y2 As Integer
' ADD START MARGE
Dim td As TerrainData
' ADD END MARGE
   
    With u
        'S̈}XN
        For i = 1 To MapWidth
            For j = 1 To MapHeight
                MaskData(i, j) = True
            Next
        Next
        
        'ړ\͂̉ۂ𒲂ׂĂ
        is_trans_available_on_ground = .IsTransAvailable("") And .Adaption(2) <> 0
        is_trans_available_in_water = .IsTransAvailable("") And .Adaption(3) <> 0
        is_trans_available_in_sky = .IsTransAvailable("") And .Adaption(1) <> 0
        If Mid$(.Data.Adaption, 3, 1) <> "-" _
            Or .IsFeatureAvailable("ړ") _
        Then
            is_adaptable_in_water = True
        End If
        If Mid$(.Data.Adaption, 4, 1) <> "-" _
            Or .IsFeatureAvailable("Fړ") _
        Then
            is_adaptable_in_space = True
        End If
        If .IsFeatureAvailable("ړ") _
            Or .IsFeatureAvailable("zo[ړ") _
        Then
            is_trans_available_on_water = True
        End If
        If .IsFeatureAvailable("߈ړ") _
            Or .IsUnderSpecialPowerEffect("߈ړ") _
        Then
            is_able_to_penetrate = True
        End If
        
' ADD START MARGE
        'n`K̂n`̃Xg쐬
        ReDim adopted_terrain(0)
        If .IsFeatureAvailable("n`K") Then
            For i = 1 To .CountFeature
                If .Feature(i) = "n`K" Then
                    buf = .FeatureData(i)
                    If LLength(buf) = 0 Then
                        ErrorMessage "jbgu" & _
                            .Name & "v̒n`K\͂ɑΉn`w肳Ă܂"
                        TerminateSRC
                    End If
                    n = LLength(buf)
                    ReDim Preserve adopted_terrain(UBound(adopted_terrain) + n - 1)
                    For j = 2 To n
                        adopted_terrain(UBound(adopted_terrain) - j + 2) = LIndex(buf, j)
                    Next
                End If
            Next
        End If
' ADD END MARGE
        
        'ړ
        ReDim allowed_terrains(0)
        If .IsFeatureAvailable("ړ") Then
            If .Area <> "" And .Area <> "n" Then
                n = LLength(.FeatureData("ړ"))
                ReDim allowed_terrains(n)
                For i = 2 To n
                    allowed_terrains(i) = LIndex(.FeatureData("ړ"), i)
                Next
            End If
        End If
        
        'is
        ReDim prohibited_terrains(0)
        If .IsFeatureAvailable("is") Then
            If .Area <> "" And .Area <> "n" Then
                n = LLength(.FeatureData("is"))
                ReDim prohibited_terrains(n)
                For i = 2 To n
                    prohibited_terrains(i) = LIndex(.FeatureData("is"), i)
                Next
            End If
        End If
        
        'ړ͈͂`FbNׂ̈
        x1 = MaxLng(1, .X - max_range)
        y1 = MaxLng(1, .Y - max_range)
        x2 = MinLng(.X + max_range, MapWidth)
        y2 = MinLng(.Y + max_range, MapHeight)
        
        'i\
        For i = x1 To x2
            For j = y1 To y2
                'ړ͈͓͂̔H
                If Abs(.X - i) + Abs(.Y - j) > max_range Then
                    GoTo NextLoop
                End If
                
                'jbg݁H
                If Not MapDataForUnit(i, j) Is Nothing Then
                    GoTo NextLoop
                End If
                
                'KH
                Select Case .Area
                    Case "n"
                        Select Case TerrainClass(i, j)
                            Case ""
                                GoTo NextLoop
                            Case ""
                                If Not is_adaptable_in_water _
                                    And Not is_trans_available_on_water _
                                    And Not is_trans_available_in_water _
                                Then
                                    GoTo NextLoop
                                End If
                            Case "["
                                If Not is_trans_available_on_water _
                                    And Not is_trans_available_in_water _
                                Then
                                    GoTo NextLoop
                                End If
                            Case "F"
                                If Not is_adaptable_in_space Then
                                    GoTo NextLoop
                                End If
                        End Select
                    Case ""
                        Select Case TerrainClass(i, j)
                            Case ""
                                GoTo NextLoop
                            Case "["
                                If Not is_trans_available_on_water _
                                    And Not is_trans_available_in_water _
                                Then
                                    GoTo NextLoop
                                End If
                            Case "F"
                                If Not is_adaptable_in_space Then
                                    GoTo NextLoop
                                End If
                        End Select
                    Case ""
                        Select Case TerrainClass(i, j)
                            Case ""
                                If TerrainMoveCost(i, j) > 100 Then
                                    GoTo NextLoop
                                End If
                            Case "F"
                                If Not is_adaptable_in_space Then
                                    GoTo NextLoop
                                End If
                        End Select
                    Case "n"
                        If TerrainClass(i, j) <> "" Then
                            GoTo NextLoop
                        End If
                    Case "F"
                        Select Case TerrainClass(i, j)
                            Case "", ""
                                If Not is_trans_available_in_sky _
                                    And Not is_trans_available_on_ground _
                                Then
                                    GoTo NextLoop
                                End If
                            Case ""
                                If Not is_trans_available_in_sky _
                                    Or TerrainMoveCost(i, j) > 100 _
                                Then
                                    GoTo NextLoop
                                End If
                            Case ""
                                If Not is_trans_available_in_water _
                                    And Not is_trans_available_on_water _
                                    And Not is_adaptable_in_water _
                                Then
                                    GoTo NextLoop
                                End If
                            Case "["
                                If Not is_trans_available_on_water _
                                    And Not is_trans_available_in_water _
                                Then
                                    GoTo NextLoop
                                End If
                        End Select
                        
                        'ړ
                        If UBound(allowed_terrains) > 0 Then
                            For k = 2 To UBound(allowed_terrains)
                                If TerrainName(i, j) = allowed_terrains(k) Then
                                    Exit For
                                End If
                            Next
                            If k > UBound(allowed_terrains) Then
                                GoTo NextLoop
                            End If
                        End If
                        
                        'is
                        For k = 2 To UBound(prohibited_terrains)
                            If TerrainName(i, j) = prohibited_terrains(k) Then
                                GoTo NextLoop
                            End If
                        Next
                End Select
                
                'Niij֎~n`H
'MOD START 240a
'                Set td = TDList.Item(MapData(i, j, 0))
'                With td
'                    If .IsFeatureAvailable("N֎~") Then
'                        For k = 1 To UBound(adopted_terrain)
'                            If .Name = adopted_terrain(k) Then
'                                Exit For
'                            End If
'                        Next
'                        If k > UBound(adopted_terrain) Then
'                            GoTo NextLoop
'                        End If
'                    End If
'                End With
                If TerrainDoNotEnter(i, j) Then
                    For k = 1 To UBound(adopted_terrain)
                        If TerrainName(i, j) = adopted_terrain(k) Then
                            Exit For
                        End If
                    Next
                    If k > UBound(adopted_terrain) Then
                        GoTo NextLoop
                    End If
                End If
'MOD START 240a
                
                'iHɕǂH
                If Not is_able_to_penetrate Then
                    If IsLineBlocked(.X, .Y, i, j, .Area = "") Then
                        GoTo NextLoop
                    End If
                End If
                
                '}XN
                MaskData(i, j) = False
NextLoop:
            Next
        Next
        
        '݂ꏊ͏ɐi\
        MaskData(.X, .Y) = False
    End With
End Sub

'Q_ԂԒǂŃubNĂ邩
Public Function IsLineBlocked(ByVal x1 As Integer, ByVal y1 As Integer, _
    ByVal x2 As Integer, ByVal y2 As Integer, _
    Optional ByVal is_flying As Boolean) As Boolean
Dim xx As Integer, yy As Integer
Dim xx2 As Integer, yy2 As Integer

    xx = x1
    yy = y1
    If Abs(x1 - x2) > Abs(y1 - y2) Then
         Do
             If x1 > x2 Then
                 xx = xx - 1
             Else
                 xx = xx + 1
             End If
             yy2 = yy
             yy = y1 + (y2 - y1) * (x1 - xx + 0#) / (x1 - x2)
             
             'ǁH
             If is_flying Then
                 If TerrainName(xx, yy) = "" _
                     Or TerrainName(xx, yy2) = "" _
                 Then
                     IsLineBlocked = True
                     Exit Function
                 End If
             Else
                 Select Case TerrainName(xx, yy)
                     Case "", "h"
                         IsLineBlocked = True
                         Exit Function
                 End Select
                 Select Case TerrainName(xx, yy2)
                     Case "", "h"
                         IsLineBlocked = True
                         Exit Function
                 End Select
             End If
         Loop Until xx = x2
    Else
         Do
             If y1 > y2 Then
                 yy = yy - 1
             Else
                 yy = yy + 1
             End If
             xx2 = xx
             xx = x1 + (x2 - x1) * (y1 - yy + 0#) / (y1 - y2)
             
             'ǁH
             If is_flying Then
                 If TerrainName(xx, yy) = "" _
                     Or TerrainName(xx2, yy) = "" _
                 Then
                     IsLineBlocked = True
                     Exit Function
                 End If
             Else
                 Select Case TerrainName(xx, yy)
                     Case "", "h"
                         IsLineBlocked = True
                         Exit Function
                 End Select
                 Select Case TerrainName(xx2, yy)
                     Case "", "h"
                         IsLineBlocked = True
                         Exit Function
                 End Select
             End If
         Loop Until yy = y2
    End If
    
    IsLineBlocked = False
End Function

'jbg u  (dst_x,dst_y) ɍŝɍł߂ړ͈͓̏ꏊ (X,Y) ͂ǂ
Public Sub NearestPoint(u As Unit, _
    ByVal dst_x As Integer, ByVal dst_y As Integer, _
    X As Integer, Y As Integer)
Dim i As Integer, j As Integer, k As Integer, n As Integer
Dim total_cost(0 To 51, 0 To 51) As Long, cur_speed(0 To 51, 0 To 51) As Long
Dim move_cost(0 To 51, 0 To 51) As Long
Dim tmp As Long
Dim is_trans_available_on_ground As Boolean
Dim is_trans_available_in_water As Boolean
Dim is_trans_available_on_water As Boolean
Dim is_adaptable_in_water As Boolean
Dim adopted_terrain() As String
Dim allowed_terrains() As String
Dim prohibited_terrains() As String
Dim is_changed As Boolean
Dim min_x As Integer, max_x As Integer
Dim min_y As Integer, max_y As Integer

    'ړIn}bvOɂȂȂ悤
    dst_x = MaxLng(MinLng(dst_x, MapWidth), 1)
    dst_y = MaxLng(MinLng(dst_y, MapHeight), 1)

    'ړ\͂̉ۂ𒲂ׂĂ
    With u
        X = .X
        Y = .Y
        
        is_trans_available_on_ground = .IsTransAvailable("") And .Adaption(2) <> 0
        is_trans_available_in_water = .IsTransAvailable("") And .Adaption(3) <> 0
        If Mid$(.Data.Adaption, 3, 1) <> "-" _
            Or .IsFeatureAvailable("ړ") _
        Then
            is_adaptable_in_water = True
        End If
        If .IsFeatureAvailable("ړ") _
            Or .IsFeatureAvailable("zo[ړ") _
        Then
            is_trans_available_on_water = True
        End If
        
        ReDim adopted_terrain(LLength(.FeatureData("n`K")))
        For i = 2 To UBound(adopted_terrain)
            adopted_terrain(i) = LIndex(.FeatureData("n`K"), i)
        Next
    End With
    
    'en`̈ړRXgZoĂ
    Select Case u.Area
        Case ""
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    If TerrainClass(i, j) = "" Then
                        move_cost(i, j) = TerrainMoveCost(i, j)
                        For k = 2 To UBound(adopted_terrain)
                            If TerrainName(i, j) = adopted_terrain(k) Then
                                move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                Exit For
                            End If
                        Next
                    Else
                        move_cost(i, j) = 2
                    End If
                Next
            Next
            
        Case "n"
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    Select Case TerrainClass(i, j)
                        Case "", "", ""
                            If is_trans_available_on_ground Then
                                move_cost(i, j) = TerrainMoveCost(i, j)
                                For k = 2 To UBound(adopted_terrain)
                                    If TerrainName(i, j) = adopted_terrain(k) Then
                                        move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                        Exit For
                                     End If
                                Next
                            Else
                                move_cost(i, j) = 1000000
                            End If
                        Case ""
                            If is_trans_available_in_water Then
                                move_cost(i, j) = 2
                            ElseIf is_adaptable_in_water Then
                                move_cost(i, j) = TerrainMoveCost(i, j)
                                For k = 2 To UBound(adopted_terrain)
                                    If TerrainName(i, j) = adopted_terrain(k) Then
                                        move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                        Exit For
                                     End If
                                Next
                            Else
                                move_cost(i, j) = 1000000
                            End If
                        Case "["
                            If is_trans_available_in_water Then
                                move_cost(i, j) = 1
                            Else
                                move_cost(i, j) = 1000000
                            End If
                        Case ""
                            move_cost(i, j) = 1000000
                    End Select
                Next
            Next
            
        Case ""
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    Select Case TerrainClass(i, j)
                        Case "", "", ""
                            If is_trans_available_on_ground Then
                                move_cost(i, j) = TerrainMoveCost(i, j)
                                For k = 2 To UBound(adopted_terrain)
                                    If TerrainName(i, j) = adopted_terrain(k) Then
                                        move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                        Exit For
                                    End If
                                Next
                            Else
                                move_cost(i, j) = 1000000
                            End If
                        Case "", "["
                           move_cost(i, j) = 2
                        Case ""
                           move_cost(i, j) = 1000000
                    End Select
                Next
            Next
            
        Case ""
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    Select Case TerrainClass(i, j)
                        Case "", "", ""
                            If is_trans_available_on_ground Then
                                move_cost(i, j) = TerrainMoveCost(i, j)
                                For k = 2 To UBound(adopted_terrain)
                                    If TerrainName(i, j) = adopted_terrain(k) Then
                                        move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                        Exit For
                                    End If
                                Next
                            Else
                                move_cost(i, j) = 1000000
                            End If
                        Case ""
                            If is_trans_available_in_water Then
                                move_cost(i, j) = 2
                            Else
                                move_cost(i, j) = TerrainMoveCost(i, j)
                                For k = 2 To UBound(adopted_terrain)
                                    If TerrainName(i, j) = adopted_terrain(k) Then
                                        move_cost(i, j) = MinLng(move_cost(i, j), 2)
                                        Exit For
                                    End If
                                Next
                            End If
                        Case "["
                            If is_trans_available_in_water Then
                                move_cost(i, j) = 1
                            Else
                                move_cost(i, j) = 1000000
                            End If
                        Case ""
                            move_cost(i, j) = 1000000
                    End Select
                Next
            Next
            
        Case "F"
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    move_cost(i, j) = TerrainMoveCost(i, j)
                    For k = 2 To UBound(adopted_terrain)
                        If TerrainName(i, j) = adopted_terrain(k) Then
                            move_cost(i, j) = MinLng(move_cost(i, j), 2)
                            Exit For
                        End If
                    Next
                Next
            Next
            
        Case "n"
            For i = 1 To MapWidth
                For j = 1 To MapHeight
                    If TerrainClass(i, j) = "" Then
                        move_cost(i, j) = 2
                    Else
                        move_cost(i, j) = 1000000
                    End If
                Next
            Next
    End Select
    
    With u
        'Hړ
        If .IsFeatureAvailable("Hړ") Then
            If .Area = "n" Then
                For i = 1 To MapWidth
                    For j = 1 To MapHeight
                        If TerrainName(i, j) = "H" Then
                            move_cost(i, j) = 1
                        Else
                            move_cost(i, j) = 1000000
                        End If
                    Next
                Next
            End If
        End If
        
        'ړ
        ReDim allowed_terrains(0)
        If .IsFeatureAvailable("ړ") Then
            If .Area <> "" And .Area <> "n" Then
                n = LLength(.FeatureData("ړ"))
                ReDim allowed_terrains(n)
                For i = 2 To n
                    allowed_terrains(i) = LIndex(.FeatureData("ړ"), i)
                Next
                For i = 1 To MapWidth
                    For j = 1 To MapHeight
                        For k = 2 To n
                            If TerrainName(i, j) = allowed_terrains(k) Then
                                Exit For
                            End If
                        Next
                        If k > n Then
                            move_cost(i, j) = 1000000
                        End If
                    Next
                Next
            End If
        End If
        
        'is
        ReDim prohibited_terrains(0)
        If .IsFeatureAvailable("is") Then
            If .Area <> "" And .Area <> "n" Then
                n = LLength(.FeatureData("is"))
                ReDim prohibited_terrains(n)
                For i = 2 To n
                    prohibited_terrains(i) = LIndex(.FeatureData("is"), i)
                Next
                For i = 1 To MapWidth
                    For j = 1 To MapHeight
                        For k = 2 To n
                            If TerrainName(i, j) = prohibited_terrains(k) Then
                                move_cost(i, j) = 1000000
                                Exit For
                            End If
                        Next
                    Next
                Next
            End If
        End If
        
        'zo[ړ
        If .IsFeatureAvailable("zo[ړ") Then
            If .Area = "n" Or .Area = "" Then
                For i = 1 To MapWidth
                    For j = 1 To MapHeight
                        Select Case TerrainName(i, j)
                            Case "", ""
                                move_cost(i, j) = 1
                        End Select
                    Next
                Next
            End If
        End If
        
        'Wvړ
        If .IsFeatureAvailable("Wvړ") Then
            If .Area = "n" Or .Area = "" Or .Area = "" Then
                For i = 1 To MapWidth
                    For j = 1 To MapHeight
                        Select Case TerrainClass(i, j)
                            Case "", ""
                                move_cost(i, j) = 1
                        End Select
                    Next
                Next
            End If
        End If
    End With
    
    For i = 0 To MapWidth + 1
        For j = 0 To MapHeight + 1
            total_cost(i, j) = 1000000
        Next
    Next
    total_cost(dst_x, dst_y) = 0
    
    'ړInen_ɓB̂ɂړ͂vZ
    i = 0
    Do
        i = i + 1
        
        '^CAEg
        If i > 3 * (MapWidth + MapHeight) Then
            Exit Do
        End If
        
        is_changed = False
        For j = 0 To MapWidth + 1
            For k = 0 To MapHeight + 1
                cur_speed(j, k) = total_cost(j, k)
            Next
        Next
        
        min_x = MaxLng(1, dst_x - i)
        max_x = MinLng(dst_x + i, MapWidth)
        For j = min_x To max_x
            min_y = MaxLng(1, dst_y - (i - Abs(dst_x - j)))
            max_y = MinLng(dst_y + (i - Abs(dst_x - j)), MapHeight)
            For k = min_y To max_y
                tmp = cur_speed(j, k)
                tmp = MinLng(tmp, cur_speed(j - 1, k))
                tmp = MinLng(tmp, cur_speed(j + 1, k))
                tmp = MinLng(tmp, cur_speed(j, k - 1))
                tmp = MinLng(tmp, cur_speed(j, k + 1))
                tmp = tmp + move_cost(j, k)
                If tmp < cur_speed(j, k) Then
                    is_changed = True
                    total_cost(j, k) = tmp
                End If
            Next
        Next
        
        'ŒZoH𔭌
        If total_cost(X, Y) <= Abs(dst_x - X) + Abs(dst_y - Y) + 2 Then
            Exit Do
        End If
    Loop While is_changed
    
    'ړ\͈͓ŖړInɍł߂ꏊt
    tmp = total_cost(X, Y)
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            If Not MaskData(i, j) Then
                If MapDataForUnit(i, j) Is Nothing Then
                    If total_cost(i, j) < tmp Then
                        X = i
                        Y = j
                        tmp = total_cost(i, j)
                    ElseIf total_cost(i, j) = tmp Then
                        If Abs(dst_x - i) ^ 2 + Abs(dst_y - j) ^ 2 _
                            < Abs(dst_x - X) ^ 2 + Abs(dst_y - Y) ^ 2 _
                        Then
                            X = i
                            Y = j
                        End If
                    End If
                End If
            End If
        Next
    Next
End Sub

'jbg u GłȂꏊ(X,Y)
Public Sub SafetyPoint(u As Unit, X As Integer, Y As Integer)
Dim i As Integer, j As Integer
Dim total_cost(0 To 51, 0 To 51) As Long, cur_cost(0 To 51, 0 To 51) As Long
Dim tmp As Long
Dim t As Unit
Dim is_changed As Boolean

    'Ɨpz
    For i = 0 To MapWidth + 1
        For j = 0 To MapHeight + 1
            total_cost(i, j) = 1000000
        Next
    Next
    For Each t In UList
        If u.IsEnemy(t) Then
            total_cost(t.X, t.Y) = 0
        End If
    Next
    
    'en_̓G̋vZ
    Do
        is_changed = False
        
        For i = 0 To MapWidth + 1
            For j = 0 To MapHeight + 1
                cur_cost(i, j) = total_cost(i, j)
            Next
        Next
        
        For i = 1 To MapWidth
            For j = 1 To MapHeight
                tmp = cur_cost(i, j)
                tmp = MinLng(cur_cost(i - 1, j) + 1, tmp)
                tmp = MinLng(cur_cost(i + 1, j) + 1, tmp)
                tmp = MinLng(cur_cost(i, j - 1) + 1, tmp)
                tmp = MinLng(cur_cost(i, j + 1) + 1, tmp)
                If tmp < cur_cost(i, j) Then
                    is_changed = True
                    total_cost(i, j) = tmp
                End If
            Next
        Next
    Loop While is_changed
    
    'ړ\͈͓œGłꏊt
    tmp = 0
    For i = 1 To MapWidth
        For j = 1 To MapHeight
            If Not MaskData(i, j) Then
                If MapDataForUnit(i, j) Is Nothing Then
                    If total_cost(i, j) > tmp Then
                        X = i
                        Y = j
                        tmp = total_cost(i, j)
                    ElseIf total_cost(i, j) = tmp Then
                        If Abs(u.X - i) ^ 2 + Abs(u.Y - j) ^ 2 _
                            < Abs(u.X - X) ^ 2 + Abs(u.Y - Y) ^ 2 _
                        Then
                            X = i
                            Y = j
                        End If
                    End If
                End If
            End If
        Next
    Next
End Sub

'݈ʒuw肵ꏊ܂ł̈ړoH𒲂ׂ
'OAreaInSpeedsĂKv
Public Sub SearchMoveRoute(tx As Integer, ty As Integer, _
    move_route_x() As Integer, move_route_y() As Integer)
Dim xx As Integer, yy As Integer
Dim nx As Integer, ny As Integer
Dim ox As Integer, oy As Integer
Dim tmp As Long, i As Integer
Dim direction As String, prev_direction As String
Dim move_direction()

    ReDim move_route_x(1)
    ReDim move_route_y(1)
    ReDim move_direction(1)
    move_route_x(1) = tx
    move_route_y(1) = ty
    
    '݈ʒu𒲂ׂ
    For xx = 1 To MapWidth
        For yy = 1 To MapHeight
            If TotalMoveCost(xx, yy) = 0 Then
                ox = xx
                oy = yy
            End If
        Next
    Next
    
    '݈ʒûynb͖
    PointInZOC(ox, oy) = 0
    
    xx = tx
    yy = ty
    nx = tx
    ny = ty
    
    Do While TotalMoveCost(xx, yy) > 0
        tmp = TotalMoveCost(xx, yy)
        
        '̏ꏊłKvړ͂ႢꏊT
        
        'ȂׂɈړ邽߁AOƓړD悳
        Select Case prev_direction
            Case "N"
                If TotalMoveCost(xx, yy - 1) < tmp _
                    And PointInZOC(xx, yy - 1) <= 0 _
                Then
                    tmp = TotalMoveCost(xx, yy - 1)
                    nx = xx
                    ny = yy - 1
                    direction = "N"
                End If
            Case "S"
                If TotalMoveCost(xx, yy + 1) < tmp _
                    And PointInZOC(xx, yy + 1) <= 0 _
                Then
                    tmp = TotalMoveCost(xx, yy + 1)
                    nx = xx
                    ny = yy + 1
                    direction = "S"
                End If
            Case "W"
                If TotalMoveCost(xx - 1, yy) < tmp _
                    And PointInZOC(xx - 1, yy) <= 0 _
                Then
                    tmp = TotalMoveCost(xx - 1, yy)
                    nx = xx - 1
                    ny = yy
                    direction = "W"
                End If
            Case "E"
                If TotalMoveCost(xx + 1, yy) < tmp _
                    And PointInZOC(xx + 1, yy) <= 0 _
                Then
                    tmp = TotalMoveCost(xx + 1, yy)
                    nx = xx + 1
                    ny = yy
                    direction = "E"
                End If
        End Select
        
        'ȂׂڕWʒut߂Œi邽߁AڕWʒuƂ̋̏
        'WɗD悵Ĉړ
        If Abs(xx - ox) <= Abs(yy - oy) Then
            If TotalMoveCost(xx, yy - 1) < tmp _
                And PointInZOC(xx, yy - 1) <= 0 _
            Then
                tmp = TotalMoveCost(xx, yy - 1)
                nx = xx
                ny = yy - 1
                direction = "N"
            End If
            If TotalMoveCost(xx, yy + 1) < tmp _
                And PointInZOC(xx, yy + 1) <= 0 _
            Then
                tmp = TotalMoveCost(xx, yy + 1)
                nx = xx
                ny = yy + 1
                direction = "S"
            End If
            If TotalMoveCost(xx - 1, yy) < tmp _
                And PointInZOC(xx - 1, yy) <= 0 _
            Then
                tmp = TotalMoveCost(xx - 1, yy)
                nx = xx - 1
                ny = yy
                direction = "W"
            End If
            If TotalMoveCost(xx + 1, yy) < tmp _
                And PointInZOC(xx + 1, yy) <= 0 _
            Then
                tmp = TotalMoveCost(xx + 1, yy)
                nx = xx + 1
                ny = yy
                direction = "E"
            End If
        Else
            If TotalMoveCost(xx - 1, yy) < tmp _
                And PointInZOC(xx - 1, yy) <= 0 _
            Then
                tmp = TotalMoveCost(xx - 1, yy)
                nx = xx - 1
                ny = yy
                direction = "W"
            End If
            If TotalMoveCost(xx + 1, yy) < tmp _
                And PointInZOC(xx + 1, yy) <= 0 _
            Then
                tmp = TotalMoveCost(xx + 1, yy)
                nx = xx + 1
                ny = yy
                direction = "E"
            End If
            If TotalMoveCost(xx, yy - 1) < tmp _
                And PointInZOC(xx, yy - 1) <= 0 _
            Then
                tmp = TotalMoveCost(xx, yy - 1)
                nx = xx
                ny = yy - 1
                direction = "N"
            End If
            If TotalMoveCost(xx, yy + 1) < tmp _
                And PointInZOC(xx, yy + 1) <= 0 _
            Then
                tmp = TotalMoveCost(xx, yy + 1)
                nx = xx
                ny = yy + 1
                direction = "S"
            End If
        End If
        
        If nx = xx And ny = yy Then
            'ȏKvړ͂ႢꏊȂ̂ŏI
            Exit Do
        End If
        
        'ꏊL^
        ReDim Preserve move_route_x(UBound(move_route_x) + 1)
        ReDim Preserve move_route_y(UBound(move_route_y) + 1)
        move_route_x(UBound(move_route_x)) = nx
        move_route_y(UBound(move_route_y)) = ny
        
        'ړL^
        ReDim Preserve move_direction(UBound(move_direction) + 1)
        move_direction(UBound(move_direction)) = direction
        prev_direction = direction
        
        '͍񌩂ꏊN_Ɍ
        xx = nx
        yy = ny
    Loop
    
    '𑖂vZ
    MovedUnitSpeed = 1
    For i = 2 To UBound(move_direction) - 1
        If move_direction(i) <> move_direction(i + 1) Then
            Exit For
        End If
        MovedUnitSpeed = MovedUnitSpeed + 1
    Next
End Sub
