VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TerrainDataList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 1997-2012 Kei Sakamoto / Inui Tetsuyuki
' {vO̓t[\tgłAۏ؂łB
' {vOGNU General Public License(Ver.3܂͂ȍ~)߂̉
' ĔЕz܂͉ς邱Ƃł܂B

'Sn`f[^Ǘ郊Xg̃NX

'n`f[^̓o^
Public Count As Integer

'n`f[^̔z
'̃XgǗpNXƈقȂzgĂ̂̓ANZX邽
Private TerrainDataList(0 To MAX_TERRAIN_DATA_NUM) As TerrainData

'n`f[^̓o^L^邽߂̔z
Private OrderList(1 To MAX_TERRAIN_DATA_NUM) As Integer


'NX̏
Private Sub Class_Initialize()
Dim i As Integer
    
    For i = 0 To MAX_TERRAIN_DATA_NUM
        Set TerrainDataList(i) = New TerrainData
    Next
End Sub

'NX̉
Private Sub Class_Terminate()
Dim i As Integer
    
    For i = 0 To MAX_TERRAIN_DATA_NUM
        Set TerrainDataList(i) = Nothing
    Next
End Sub


'w肵f[^͓o^Ă邩H
Public Function IsDefined(ByVal ID As Integer) As Boolean
    If TerrainDataList(ID).ID >= 0 Then
        IsDefined = True
    Else
        IsDefined = False
    End If
End Function


'n`f[^Xgw肵f[^o
Public Function Item(ByVal ID As Integer) As TerrainData
    Set Item = TerrainDataList(ID)
End Function

'w肵f[^̖
Public Function Name(ByVal ID As Integer) As String
    Name = TerrainDataList(ID).Name
End Function

'w肵f[^̉摜t@C
Public Function Bitmap(ByVal ID As Integer) As String
    Bitmap = TerrainDataList(ID).Bitmap
End Function

'w肵f[^̃NX
Public Function Class(ByVal ID As Integer) As String
    Class = TerrainDataList(ID).Class
End Function

'w肵f[^̈ړRXg
Public Function MoveCost(ByVal ID As Integer) As Integer
    MoveCost = TerrainDataList(ID).MoveCost
End Function

'w肵f[^̖C
Public Function HitMod(ByVal ID As Integer) As Integer
    HitMod = TerrainDataList(ID).HitMod
End Function

'w肵f[^̃_[WC
Public Function DamageMod(ByVal ID As Integer) As Integer
    DamageMod = TerrainDataList(ID).DamageMod
End Function


'w肵f[^̓\

Public Function IsFeatureAvailable(ByVal ID As Integer, ftype As String) As Boolean
    IsFeatureAvailable = TerrainDataList(ID).IsFeatureAvailable(ftype)
End Function

Public Function FeatureLevel(ByVal ID As Integer, ftype As String) As Double
    FeatureLevel = TerrainDataList(ID).FeatureLevel(ftype)
End Function

Public Function FeatureData(ByVal ID As Integer, ftype As String) As String
    FeatureData = TerrainDataList(ID).FeatureData(ftype)
End Function


'mԖڂɓo^f[^̔ԍ
Public Function OrderedID(ByVal n As Integer) As Integer
    OrderedID = OrderList(n)
End Function


'f[^t@C fname f[^[h
Public Sub Load(fname As String)
Dim FileNumber As Integer
Dim ret As Integer, line_num As Long
Dim i As Integer, j As Integer
Dim line_buf As String, buf As String, buf2 As String
Dim td As TerrainData
Dim data_id As Integer, data_name As String
Dim err_msg As String
Dim in_quote As Boolean

    On Error GoTo ErrorHandler
    
    FileNumber = FreeFile
    Open fname For Input Access Read As #FileNumber
    
    line_num = 0
    
    Do While True
        data_name = ""
        
        Do
            If EOF(FileNumber) Then
                Close #FileNumber
                Exit Sub
            End If
            GetLine FileNumber, line_buf, line_num
        Loop While Len(line_buf) = 0
        
        'ԍ
        If IsNumeric(line_buf) Then
            data_id = CInt(line_buf)
        Else
            err_msg = "ԍ̐ݒ肪ԈĂ܂B"
            Error 0
        End If
        If data_id < 0 Or data_id >= MAX_TERRAIN_DATA_NUM Then
            err_msg = "ԍ̐ݒ肪ԈĂ܂B"
            Error 0
        End If
        
        Set td = TerrainDataList(data_id)
        
        With td
            'VKo^H
            If .ID < 0 Then
                Count = Count + 1
                OrderList(Count) = data_id
            Else
                .Clear
            End If
            .ID = data_id
            
            ', 摜t@C
            GetLine FileNumber, line_buf, line_num
            
            '
            ret = InStr(line_buf, ",")
            If ret = 0 Then
                err_msg = "摜t@CĂ܂B"
                Error 0
            End If
            data_name = Trim$(Left$(line_buf, ret - 1))
            .Name = data_name
            buf = Mid$(line_buf, ret + 1)
            
            '摜t@C
            .Bitmap = Trim$(buf)
            If Len(.Bitmap) = 0 Then
                err_msg = "摜t@Cw肳Ă܂B"
                Error 0
            End If
            
            'n`^Cv, ړRXg, C, _[WC
            GetLine FileNumber, line_buf, line_num
            
            'n`^Cv
            ret = InStr(line_buf, ",")
            If ret = 0 Then
                err_msg = "ړRXgĂ܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(line_buf, ret - 1))
            buf = Mid$(line_buf, ret + 1)
            .Class = buf2
            
            'ړRXg
            ret = InStr(buf, ",")
            If ret = 0 Then
                err_msg = "CĂ܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            If buf2 = "-" Then
                .MoveCost = 1000
            ElseIf IsNumeric(buf2) Then
                '0.5݂̈ړRXgg悤ɂ邽߁Aۂ̂Q{̒lŋL^
                .MoveCost = CInt(2 * CDbl(buf2))
            End If
            If .MoveCost <= 0 Then
                DataErrorMessage "ړRXg̐ݒ肪ԈĂ܂B", _
                    fname, line_num, line_buf, data_name
            End If
            
            'C
            ret = InStr(buf, ",")
            If ret = 0 Then
                err_msg = "_[WCĂ܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            If IsNumeric(buf2) Then
                .HitMod = CInt(buf2)
            Else
                DataErrorMessage "C̐ݒ肪ԈĂ܂B", _
                    fname, line_num, line_buf, data_name
            End If
            
            '_[WC
            ret = InStr(buf, ",")
            If ret > 0 Then
                err_msg = "]ȁu,vw肳Ă܂B"
                Error 0
            End If
            buf2 = Trim$(buf)
            If IsNumeric(buf2) Then
                .DamageMod = CInt(buf2)
            Else
                DataErrorMessage "_[WC̐ݒ肪ԈĂ܂B", _
                    fname, line_num, line_buf, data_name
            End If
            
            'n`
            GetLine FileNumber, line_buf, line_num
            Do While Len(line_buf) > 0
                buf = line_buf
                i = 0
                Do While Len(buf) > 0
                    i = i + 1
                    
                    ret = 0
                    in_quote = False
                    For j = 1 To Len(buf)
                        Select Case Mid$(buf, j, 1)
                            Case ","
                                If Not in_quote Then
                                    ret = j
                                    Exit For
                                End If
                            Case """"
                                in_quote = Not in_quote
                        End Select
                    Next
                    
                    If ret > 0 Then
                        buf2 = Trim$(Left$(buf, ret - 1))
                        buf = Trim$(Mid$(buf, ret + 1))
                    Else
                        buf2 = buf
                        buf = ""
                    End If
                    
                    If buf2 <> "" Then
                        .AddFeature buf2
                    Else
                        DataErrorMessage "s" & Format$(i) & _
                            "Ԗڂ̒n`ʂ̐ݒ肪ԈĂ܂B", _
                            fname, line_num, line_buf, data_name
                    End If
                Loop
                
                If EOF(FileNumber) Then
                    Close #FileNumber
                    Exit Sub
                End If
                
                GetLine FileNumber, line_buf, line_num
            Loop
        End With
    Loop
    
ErrorHandler:
    'G[
    If line_num = 0 Then
        ErrorMessage fname & "J܂B"
    Else
        Close #FileNumber
        DataErrorMessage err_msg, fname, line_num, line_buf, data_name
    End If
    
    End
End Sub

'XgNA
Public Sub Clear()
Dim i As Integer
    
    For i = 0 To MAX_TERRAIN_DATA_NUM - 1
        TerrainDataList(i).Clear
    Next
    Count = 0
End Sub

